// ---------------------------------------------------*- C++ -*--------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollectionoperatorH
#define __CONCERT_ilocollectionoperatorH

#if !defined(__CONCERT_ilotuplecollectionH)
# include <ilconcert/ilotuplecollection.h>
#endif
#if !defined(__CONCERT_ilosymbolH)
# include <ilconcert/ilosymbol.h>
#endif
#if !defined(__CONCERT_iloanyexpriH)
# include <ilconcert/iloanyexpri.h>
#endif

class IloIntExprArg;
class IloNumExprArg;
class IloTupleExprArg;

IloIntSet IloUnion(IloIntSet set1, IloIntSet set2);
IloNumSet IloUnion(IloNumSet set1, IloNumSet set2);
IloAnySet IloUnion(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloUnion(IloSymbolSet set1, IloSymbolSet set2);


IloTupleSet IloUnion(IloTupleSet set1, IloTupleSet set2);

IloInt IloFirst(IloIntSet set);
IloNum IloFirst(IloNumSet set);
IloAny IloFirst(IloAnySet set);
IloSymbol IloFirst(IloSymbolSet set);

IloTuple IloFirst(IloTupleSet set);

IloInt IloLast(IloIntSet set);
IloNum IloLast(IloNumSet set);
IloAny IloLast(IloAnySet set);
IloSymbol IloLast(IloSymbolSet set);


IloTuple IloLast(IloTupleSet set);


IloIntSet IloExclude(IloIntSet set1, IloIntSet set2);
IloNumSet IloExclude(IloNumSet set1, IloNumSet set2);
IloAnySet IloExclude(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloExclude(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloExclude(IloTupleSet set1, IloTupleSet set2);


IloIntSet IloSymExclude(IloIntSet set1, IloIntSet set2);
IloNumSet IloSymExclude(IloNumSet set1, IloNumSet set2);
IloAnySet IloSymExclude(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloSymExclude(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloSymExclude(IloTupleSet set1, IloTupleSet set2, IloBool checkDuplicates = IloTrue);






IloIntSet IloInter(IloIntSet set1, IloIntSet set2);
IloNumSet IloInter(IloNumSet set1, IloNumSet set2);
IloAnySet IloInter(IloAnySet set1, IloAnySet set2);
IloSymbolSet IloInter(IloSymbolSet set1, IloSymbolSet set2);

IloTupleSet IloInter(IloTupleSet set1, IloTupleSet set2);


IloInt IloNext(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloNext(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloNext(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloNext(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloNext(IloSymbolSet set, IloSymbol value, IloInt n=1);



//=================================================

IloInt IloPrevious(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloPrevious(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloPrevious(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloPrevious(IloTupleSet set, IloTuple value, IloInt n=1);
IloSymbol IloPrevious(IloSymbolSet set, IloSymbol value, IloInt n=1);

IloInt IloNextC(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloNextC(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloNextC(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloNextC(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloNextC(IloSymbolSet set, IloSymbol value, IloInt n=1);

IloInt IloPreviousC(IloIntSet set, IloInt value, IloInt n=1);

IloNum IloPreviousC(IloNumSet set, IloNum value, IloInt n=1);

IloAny IloPreviousC(IloAnySet set, IloAny value, IloInt n=1);

IloTuple IloPreviousC(IloTupleSet set, IloTuple value, IloInt n=1);

IloSymbol IloPreviousC(IloSymbolSet set, IloSymbol value, IloInt n=1);


IloIntExprArg IloNext(IloIntSet set, IloIntExprArg value);

IloNumExprArg IloNext(IloNumSet set, IloNumExprArg value);

IloTupleExprArg IloNext(IloTupleSet set, IloTupleExprArg value);

IloSymbolExprArg IloNext(IloSymbolSet set, IloSymbolExprArg value);


IloIntExprArg IloItem(IloIntSet set, IloIntExprArg value);

IloNumExprArg IloItem(IloNumSet set, IloIntExprArg value);

IloTupleExprArg IloItem(IloTupleSet set, IloIntExprArg value);

IloSymbolExprArg IloItem(IloSymbolSet set, IloIntExprArg value);



IloIntExprArg IloPrevious(IloIntSet set, IloIntExprArg value);

IloNumExprArg IloPrevious(IloNumSet set, IloNumExprArg value);

IloTupleExprArg IloPrevious(IloTupleSet set, IloTupleExprArg value);

IloSymbolExprArg IloPrevious(IloSymbolSet set, IloSymbolExprArg value);

IloIntExprArg IloNextC(IloIntSet set, IloIntExprArg value);

IloNumExprArg IloNextC(IloNumSet set, IloNumExprArg value);

IloTupleExprArg IloNextC(IloTupleSet set, IloTupleExprArg value);

IloSymbolExprArg IloNextC(IloSymbolSet set, IloSymbolExprArg value);


IloIntExprArg IloPreviousC(IloIntSet set, IloIntExprArg value);

IloNumExprArg IloPreviousC(IloNumSet set, IloNumExprArg value);

IloTupleExprArg IloPreviousC(IloTupleSet set, IloTupleExprArg value);

IloSymbolExprArg IloPreviousC(IloSymbolSet set, IloSymbolExprArg value);



IloIntExprArg IloNext(IloIntSet set, IloIntExprArg value, IloIntExprArg n);

IloNumExprArg IloNext(IloNumSet set, IloNumExprArg value, IloIntExprArg n);

IloTupleExprArg IloNext(IloTupleSet set, IloTupleExprArg value, IloIntExprArg n);

IloSymbolExprArg IloNext(IloSymbolSet set, IloSymbolExprArg value, IloIntExprArg n);


IloIntExprArg IloPrevious(IloIntSet set, IloIntExprArg value, IloIntExprArg n);

IloNumExprArg IloPrevious(IloNumSet set, IloNumExprArg value, IloIntExprArg n);

IloTupleExprArg IloPrevious(IloTupleSet set, IloTupleExprArg value, IloIntExprArg n);

IloSymbolExprArg IloPrevious(IloSymbolSet set, IloSymbolExprArg value, IloIntExprArg n);


IloIntExprArg IloNextC(IloIntSet set, IloIntExprArg value, IloIntExprArg n);


IloNumExprArg IloNextC(IloNumSet set, IloNumExprArg value, IloIntExprArg n);

IloTupleExprArg IloNextC(IloTupleSet set, IloTupleExprArg value, IloIntExprArg n);

IloSymbolExprArg IloNextC(IloSymbolSet set, IloSymbolExprArg value, IloIntExprArg n);


IloIntExprArg IloPreviousC(IloIntSet set, IloIntExprArg value, IloIntExprArg n);

IloNumExprArg IloPreviousC(IloNumSet set, IloNumExprArg value, IloIntExprArg n);

IloTupleExprArg IloPreviousC(IloTupleSet set, IloTupleExprArg value, IloIntExprArg n);

IloSymbolExprArg IloPreviousC(IloSymbolSet set, IloSymbolExprArg value, IloIntExprArg n);



IloIntExprArg IloNext(IloIntSet set, IloInt value, IloIntExprArg n);

IloNumExprArg IloNext(IloNumSet set, IloNum value, IloIntExprArg n);

IloTupleExprArg IloNext(IloTupleSet set, IloTuple value, IloIntExprArg n);

IloSymbolExprArg IloNext(IloSymbolSet set, IloSymbol value, IloIntExprArg n);




IloIntExprArg IloPrevious(IloIntSet set, IloInt value, IloIntExprArg n);

IloNumExprArg IloPrevious(IloNumSet set, IloNum value, IloIntExprArg n);

IloTupleExprArg IloPrevious(IloTupleSet set, IloTuple value, IloIntExprArg n);

IloSymbolExprArg IloPrevious(IloSymbolSet set, IloSymbol value, IloIntExprArg n);


IloIntExprArg IloNextC(IloIntSet set, IloInt value, IloIntExprArg n);


IloNumExprArg IloNextC(IloNumSet set, IloNum value, IloIntExprArg n);

IloTupleExprArg IloNextC(IloTupleSet set, IloTuple value, IloIntExprArg n);

IloSymbolExprArg IloNextC(IloSymbolSet set, IloSymbol value, IloIntExprArg n);


IloIntExprArg IloPreviousC(IloIntSet set, IloInt value, IloIntExprArg n);

IloNumExprArg IloPreviousC(IloNumSet set, IloNum value, IloIntExprArg n);

IloTupleExprArg IloPreviousC(IloTupleSet set, IloTuple value, IloIntExprArg n);

IloSymbolExprArg IloPreviousC(IloSymbolSet set, IloSymbol value, IloIntExprArg n);



class IloIntSetOperatorI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntSetI* _coll;
	IloIntExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntSetI* getIntSet() const { return _coll; }
	IloIntExprI* getIntExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloIntSetOperatorI(IloEnvI* env,
		IloIntSetI* coll,
		IloIntExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloIntExprI(env), _coll(coll), _expr(index->intLockExpr()), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloIntSetOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};

class IloNumSetOperatorI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumSetI* _coll;
	IloNumExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumSetI* getNumSet() const { return _coll; }
	IloNumExprI* getNumExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloNumSetOperatorI(IloEnvI* env,
		IloNumSetI* coll,
		IloNumExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloNumExprI(env), _coll(coll), _expr(index->lockExpr()), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloNumSetOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};

class IloSymbolSetOperatorI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnySetI* _coll;
	IloAnyExprI* _expr;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnySetI* getAnySet() const { return _coll; }
	IloAnyExprI* getAnyExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloSymbolSetOperatorI(IloEnvI* env,
		IloAnySetI* coll,
		IloAnyExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloAnyExprI(env), _coll(coll), _expr(index->lockExpr()), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloSymbolSetOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


class IloTupleSetOperatorI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloTupleSetI* _coll;
	IloAnyExprI* _expr;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloTupleSetI* getTupleSet() const { return _coll; }
	IloAnyExprI* getAnyExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloTupleSetOperatorI(IloEnvI* env,
		IloTupleSetI* coll,
		IloAnyExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloAnyExprI(env), _coll(coll), _expr(index->lockExpr()), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloTupleSetOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};

//====================================================


class IloIntSetItemI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntSetI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntSetI* getIntSet() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloIntSetItemI(IloEnvI* env,
		IloIntSetI* coll,
		IloIntExprI* offset = 0) :
	IloIntExprI(env), _coll(coll), _offset(0) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloIntSetItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};

class IloNumSetItemI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumSetI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumSetI* getNumSet() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloNumSetItemI(IloEnvI* env,
		IloNumSetI* coll,
		IloIntExprI* offset = 0) :
	IloNumExprI(env), _coll(coll), _offset(0) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloNumSetItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};

class IloSymbolSetItemI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnySetI* _coll;
	IloIntExprArgI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnySetI* getAnySet() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloSymbolSetItemI(IloEnvI* env,
		IloAnySetI* coll,
		IloIntExprI* offset = 0) :
	IloAnyExprI(env), _coll(coll), _offset(0) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloSymbolSetItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


class IloTupleSetItemI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloTupleSetI* _coll;
	IloIntExprArgI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloTupleSetI* getTupleSet() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloTupleSetItemI(IloEnvI* env,
		IloTupleSetI* coll,
		IloIntExprI* offset = 0) :
	IloAnyExprI(env), _coll(coll), _offset(0) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloTupleSetItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};




//===================================


class IloIntSetOperatorCstI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntSetI* _coll;
	IloInt _value;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntSetI* getIntSet() const { return _coll; }
	IloInt getIntValue() const { return _value; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloIntSetOperatorCstI(IloEnvI* env,
		IloIntSetI* coll,
		IloInt index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloIntExprI(env), _coll(coll), _value(index), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloIntSetOperatorCstI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};

class IloNumSetOperatorCstI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumSetI* _coll;
	IloNum _value;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumSetI* getNumSet() const { return _coll; }
	IloNum getNumValue() const { return _value; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloNumSetOperatorCstI(IloEnvI* env,
		IloNumSetI* coll,
		IloNum index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloNumExprI(env), _coll(coll), _value(index), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloNumSetOperatorCstI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};

class IloSymbolSetOperatorCstI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnySetI* _coll;
	IloAny _value;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnySetI* getAnySet() const { return _coll; }
	IloAny getAnyValue() const { return _value; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloSymbolSetOperatorCstI(IloEnvI* env,
		IloAnySetI* coll,
		IloAny index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloAnyExprI(env), _coll(coll), _value(index), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloSymbolSetOperatorCstI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


class IloTupleSetOperatorCstI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloTupleSetI* _coll;
	IloAny _value;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloTupleSetI* getTupleSet() const { return _coll; }
	IloAny getAnyValue() const { return _value; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloTupleSetOperatorCstI(IloEnvI* env,
		IloTupleSetI* coll,
		IloAny index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue) :
	IloAnyExprI(env), _coll(coll), _value(index), _offset(0), _circ(circ), _sense(sense) {
		if (offset) _offset = offset->intLockExpr();
	}
	virtual ~IloTupleSetOperatorCstI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


//===========================



class IloIntCollectionExprArg;
class IloNumCollectionExprArg;
class IloSymbolCollectionExprArg;

IloIntExprArg IloNext(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloNext(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloPrevious(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloPrevious(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloNextC(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloNextC(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);
IloIntExprArg IloPreviousC(IloIntCollectionExprArg set, IloIntExprArg value);
IloIntExprArg IloPreviousC(IloIntCollectionExprArg set, IloIntExprArg value, IloIntExprArg n);


IloNumExprArg IloNext(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloNext(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloPrevious(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloPrevious(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloNextC(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloNextC(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);
IloNumExprArg IloPreviousC(IloNumCollectionExprArg set, IloNumExprArg value);
IloNumExprArg IloPreviousC(IloNumCollectionExprArg set, IloNumExprArg value, IloIntExprArg n);

IloSymbolExprArg IloNext(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloNext(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloPrevious(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloPrevious(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloNextC(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloNextC(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);
IloSymbolExprArg IloPreviousC(IloSymbolCollectionExprArg set, IloSymbolExprArg value);
IloSymbolExprArg IloPreviousC(IloSymbolCollectionExprArg set, IloSymbolExprArg value, IloIntExprArg n);


#define IloNumCollectionExprI IloNumExprI
#define IloIntCollectionExprI IloIntExprI
#define IloAnyCollectionExprI IloAnyExprI

class IloNumCollectionExprOperatorI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumCollectionExprI* _coll;
	IloNumExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumCollectionExprI* getNumCollectionExpr() const { return _coll; }
	IloNumExprI* getNumExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloNumCollectionExprOperatorI(IloEnvI* env,
		IloNumCollectionExprI* coll,
		IloNumExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloNumCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};


class IloIntCollectionExprOperatorI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntCollectionExprI* _coll;
	IloIntExprI* _expr;
	IloIntExprI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntCollectionExprI* getIntCollectionExpr() const { return _coll; }
	IloIntExprI* getIntExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloIntCollectionExprOperatorI(IloEnvI* env,
		IloIntCollectionExprI* coll,
		IloIntExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloIntCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};


class IloSymbolCollectionExprOperatorI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _coll;
	IloAnyExprI* _expr;
	IloIntExprArgI* _offset;
	IloBool _circ;
	IloBool _sense;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnyCollectionExprI* getAnyCollectionExpr() const { return _coll; }
	IloAnyExprI* getAnyExpr() const { return _expr; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloBool isCircular() const { return _circ; }
	IloBool isNext() const { return _sense; }
	IloSymbolCollectionExprOperatorI(IloEnvI* env,
		IloAnyCollectionExprI* coll,
		IloAnyExprI* index,
		IloIntExprI* offset = 0,
		IloBool sense = IloTrue,
		IloBool circ = IloTrue);
	virtual ~IloSymbolCollectionExprOperatorI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};

//============================

class IloNumCollectionExprItemI : public IloNumExprI {
	ILOEXTRDECL
private:
	IloNumCollectionExprI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloNumCollectionExprI* getNumCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloNumCollectionExprItemI(IloEnvI* env,
		IloNumCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloNumCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	virtual IloBool isInteger() const;
};


class IloIntCollectionExprItemI : public IloIntExprI {
	ILOEXTRDECL
private:
	IloIntCollectionExprI* _coll;
	IloIntExprI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloIntCollectionExprI* getIntCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloIntCollectionExprItemI(IloEnvI* env,
		IloIntCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloIntCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
};


class IloSymbolCollectionExprItemI : public IloAnyExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _coll;
	IloIntExprArgI* _offset;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloAnyCollectionExprI* getAnyCollectionExpr() const { return _coll; }
	IloIntExprI* getOffSet() const { return _offset; }
	IloSymbolCollectionExprItemI(IloEnvI* env,
		IloAnyCollectionExprI* coll,
		IloIntExprI* offset = 0);
	virtual ~IloSymbolCollectionExprItemI();
	void display(ILOSTD(ostream)& out) const;
	virtual IloNum eval(const IloAlgorithm alg) const;
	virtual IloExtractableI* makeClone(IloEnvI*) const;
	IloEncoderI* getEncoder() const;
};


IloIntExprArg IloItem(IloIntCollectionExprArg set, IloIntExprArg n);
IloNumExprArg IloItem(IloNumCollectionExprArg set, IloIntExprArg n);
IloSymbolExprArg IloItem(IloSymbolCollectionExprArg set, IloIntExprArg n);


#endif

