// -------------------------------------------------------*- C++ -*----------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollexprH
#define __CONCERT_ilocollexprH

#if !defined(__CONCERT_ilomapiH)
#include <ilconcert/ilomapi.h>
#endif

class IloGenerator;

class IloIntCollectionExprGenerator;
class IloNumCollectionExprGenerator;
class IloSymbolCollectionExprGenerator;

//-----------------------------------------------------------------
class IloIntCollectionExprGenerator : public IloGenerator {
public:
	IloIntCollectionExprGenerator();
	IloIntCollectionExprGenerator(IloIntCollectionExprGeneratorI* impl);
	IloIntCollectionExprGeneratorI* getImpl() const;
	/* <p> . </p> */
	IloIntIndex getIndex() const;
};

//--------------------------

class IloNumCollectionExprGenerator : public IloGenerator {
public:
	IloNumCollectionExprGenerator();
	IloNumCollectionExprGenerator(IloNumCollectionExprGeneratorI* impl);
	IloNumCollectionExprGeneratorI* getImpl() const;
	/* <p> . </p> */
	IloNumIndex getIndex() const;
};

class IloSymbolCollectionExprGenerator : public IloGenerator {
public:
	IloSymbolCollectionExprGenerator();
	IloSymbolCollectionExprGenerator(IloSymbolCollectionExprGeneratorI* impl);
	IloSymbolCollectionExprGeneratorI* getImpl() const;
	/* <p> . </p> */
	IloSymbolIndex getIndex() const;
};


IloConstraint IloMember(const IloEnv env,
						const IloSymbolExprArg exp,
						const IloSymbolCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const IloSymbol val,
						const IloSymbolCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const char* val,
						const IloSymbolCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const IloNumExprArg exp,
						const IloNumCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const IloNum val,
						const IloNumCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const IloIntExprArg exp,
						const IloIntCollectionExprArg arg);

IloConstraint IloMember(const IloEnv env,
						const IloInt val,
						const IloIntCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloSymbolExprArg exp,
						   const IloSymbolCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloSymbol val,
						   const IloSymbolCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const char* val,
						   const IloSymbolCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloNumExprArg exp,
						   const IloNumCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloNum val,
						   const IloNumCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloIntExprArg exp,
						   const IloIntCollectionExprArg arg);

IloConstraint IloNotMember(const IloEnv env,
						   const IloInt val,
						   const IloIntCollectionExprArg arg);



IloIntExprArg IloCard(const IloIntCollectionExprArg e);

IloIntExprArg IloCard(const IloSymbolCollectionExprArg e);

IloIntExprArg IloCard(const IloNumCollectionExprArg e);


IloIntExprArg IloMin(const IloIntCollectionExprArg e);

IloNumExprArg IloMin(const IloNumCollectionExprArg e);

IloNumExprArg IloMax(const IloNumCollectionExprArg y);

IloIntExprArg IloMax(const IloIntCollectionExprArg y);





IloIntExprArg IloOrd (const IloIntCollectionExprArg coll, const IloIntExprArg x);
IloIntExprArg IloOrd (const IloNumCollectionExprArg coll, const IloNumExprArg y);
IloIntExprArg IloOrd (const IloSymbolCollectionExprArg coll, const IloSymbolExprArg y);


IloIntExprArg IloOrd(const IloIntCollectionExprArg coll, IloInt x);

IloIntExprArg IloOrd(const IloNumCollectionExprArg coll, IloNum x);

IloIntExprArg IloOrd(const IloSymbolCollectionExprArg coll, IloSymbol );


IloConstraint IloOrdered(const IloIntCollectionExprArg coll,
						 const IloIntExprArg exp1,
						 const IloIntExprArg exp2);

IloConstraint IloOrdered(const IloIntCollectionExprArg coll,
						 const IloIntExprArg arg,
						 const IloInt set);

IloConstraint IloOrdered(const IloIntCollectionExprArg map,
						 const IloInt set,
						 const IloIntExprArg arg);


IloConstraint IloOrdered(const IloNumCollectionExprArg map,
						 const IloNumExprArg exp1,
						 const IloNumExprArg exp2);

IloConstraint IloOrdered(const IloNumCollectionExprArg map,
						 const IloNumExprArg arg,
						 const IloNum set);

IloConstraint IloOrdered(const IloNumCollectionExprArg map,
						 const IloNum set,
						 const IloNumExprArg arg);


IloConstraint IloOrdered(const IloSymbolCollectionExprArg map,
						 const IloSymbolExprArg exp1,
						 const IloSymbolExprArg exp2);

IloConstraint IloOrdered(const IloSymbolCollectionExprArg map,
						 const IloSymbolExprArg arg,
						 const IloSymbol set);

IloConstraint IloOrdered(const IloSymbolCollectionExprArg map,
						 const IloSymbol set,
						 const IloSymbolExprArg arg);





IloIntSet IloUnion(IloGeneratorArray gen, const IloIntCollectionExprArg expr);

IloSymbolSet IloUnion(IloGeneratorArray gen, const IloSymbolCollectionExprArg expr);

IloNumSet IloUnion(IloGeneratorArray gen, const IloNumCollectionExprArg expr);



IloIntSet IloInter(IloGeneratorArray gen, const IloIntCollectionExprArg expr);

IloSymbolSet IloInter(IloGeneratorArray gen, const IloSymbolCollectionExprArg expr);

IloNumSet IloInter(IloGeneratorArray gen, const IloNumCollectionExprArg expr);



IloIntSet IloSymExclude(IloGeneratorArray gen, const IloIntCollectionExprArg expr);

IloSymbolSet IloSymExclude(IloGeneratorArray gen, const IloSymbolCollectionExprArg expr);

IloNumSet IloSymExclude(IloGeneratorArray gen, const IloNumCollectionExprArg expr);


IloIntSet IloExclude(IloGeneratorArray gen, const IloIntCollectionExprArg expr);

IloSymbolSet IloExclude(IloGeneratorArray gen, const IloSymbolCollectionExprArg expr);

IloNumSet IloExclude(IloGeneratorArray gen, const IloNumCollectionExprArg expr);

IloIntSet IloUnion(IloGenerator gen1, IloGenerator gen2, const IloIntCollectionExprArg expr);
IloIntSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, const IloIntCollectionExprArg expr);
IloIntSet IloExclude(IloGenerator gen1, IloGenerator gen2, const IloIntCollectionExprArg expr);

IloIntSet IloUnion(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloIntCollectionExprArg expr);
IloIntSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloIntCollectionExprArg expr);
IloIntSet IloExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloIntCollectionExprArg expr);

IloSymbolSet IloUnion(IloGenerator gen1, IloGenerator gen2, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloExclude(IloGenerator gen1, IloGenerator gen2, const IloSymbolCollectionExprArg expr);

IloSymbolSet IloUnion(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloSymbolCollectionExprArg expr);

IloNumSet IloUnion(IloGenerator gen1, IloGenerator gen2, const IloNumCollectionExprArg expr);
IloNumSet IloExclude(IloGenerator gen1, IloGenerator gen2, const IloNumCollectionExprArg expr);
IloNumSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, const IloNumCollectionExprArg expr);

IloNumSet IloUnion(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloNumCollectionExprArg expr);
IloNumSet IloExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloNumCollectionExprArg expr);
IloNumSet IloSymExclude(IloGenerator gen1, IloGenerator gen2, IloGenerator gen3, const IloNumCollectionExprArg expr);



///////

IloIntCollectionExprArg IloUnion(const IloIntCollectionExprArg expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloUnion(const IloIntSet expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloUnion(const IloIntCollectionExprArg expr1, const IloIntSet expr2);
//----

IloSymbolCollectionExprArg IloUnion(const IloSymbolCollectionExprArg expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloUnion(const IloSymbolSet expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloUnion(const IloSymbolCollectionExprArg expr1, const IloSymbolSet expr2);

//---

IloNumCollectionExprArg IloUnion(const IloNumCollectionExprArg expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloUnion(const IloNumSet expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloUnion(const IloNumCollectionExprArg expr1, const IloNumSet expr2);

//---


IloIntCollectionExprArg IloSymExclude(const IloIntCollectionExprArg expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloSymExclude(const IloIntSet expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloSymExclude(const IloIntCollectionExprArg expr1, const IloIntSet expr2);

//------------

IloSymbolCollectionExprArg IloSymExclude(const IloSymbolCollectionExprArg expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloSymExclude(const IloSymbolSet expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloSymExclude(const IloSymbolCollectionExprArg expr1, const IloSymbolSet expr2);

IloNumCollectionExprArg IloSymExclude(const IloNumCollectionExprArg expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloSymExclude(const IloNumSet expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloSymExclude(const IloNumCollectionExprArg expr1, const IloNumSet expr2);


IloIntCollectionExprArg IloExclude(const IloIntCollectionExprArg expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloExclude(const IloIntSet expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloExclude(const IloIntCollectionExprArg expr1, const IloIntSet expr2);

IloSymbolCollectionExprArg IloExclude(const IloSymbolCollectionExprArg expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloExclude(const IloSymbolSet expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloExclude(const IloSymbolCollectionExprArg expr1, const IloSymbolSet expr2);

IloNumCollectionExprArg IloExclude(const IloNumCollectionExprArg expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloExclude(const IloNumSet expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloExclude(const IloNumCollectionExprArg expr1, const IloNumSet expr2);


IloIntCollectionExprArg IloInter(const IloIntCollectionExprArg expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloInter(const IloIntSet expr1, const IloIntCollectionExprArg expr2);
IloIntCollectionExprArg IloInter(const IloIntCollectionExprArg expr1, const IloIntSet expr2);

IloSymbolCollectionExprArg IloInter(const IloSymbolCollectionExprArg expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloInter(const IloSymbolSet expr1, const IloSymbolCollectionExprArg expr2);
IloSymbolCollectionExprArg IloInter(const IloSymbolCollectionExprArg expr1, const IloSymbolSet expr2);

IloNumCollectionExprArg IloInter(const IloNumCollectionExprArg expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloInter(const IloNumSet expr1, const IloNumCollectionExprArg expr2);
IloNumCollectionExprArg IloInter(const IloNumCollectionExprArg expr1, const IloNumSet expr2);



IloIntSet IloUnion(IloGenerator gen, const IloIntCollectionExprArg expr);
IloIntSet IloSymExclude(IloGenerator gen, const IloIntCollectionExprArg expr);
IloIntSet IloExclude(IloGenerator gen, const IloIntCollectionExprArg expr);


IloNumSet IloUnion(IloGenerator gen, const IloNumCollectionExprArg expr);
IloNumSet IloSymExclude(IloGenerator gen, const IloNumCollectionExprArg expr);
IloNumSet IloExclude(IloGenerator gen, const IloNumCollectionExprArg expr);


IloSymbolSet IloUnion(IloGenerator gen, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloSymExclude(IloGenerator gen, const IloSymbolCollectionExprArg expr);
IloSymbolSet IloExclude(IloGenerator gen, const IloSymbolCollectionExprArg expr);

IloIntExprArg IloFirst(IloIntCollectionExprArg coll);
IloIntExprArg IloLast(IloIntCollectionExprArg coll);

IloNumExprArg IloFirst(IloNumCollectionExprArg coll);
IloNumExprArg IloLast(IloNumCollectionExprArg coll);

IloSymbolExprArg IloFirst(IloSymbolCollectionExprArg coll);
IloSymbolExprArg IloLast(IloSymbolCollectionExprArg coll);

IloTupleExprArg IloLast(IloTupleSetExprArg coll);
IloTupleExprArg IloLast(IloTupleSetExprArg coll);


////////////////////////////////////////////////////////
ILOSUBMAPHANDLE(IloAnyCollection, IloAnyCollectionExprArg)

#define IloSymbolCollectionSubMapExprI IloAnyCollectionSubMapExprI
#define IloSymbolCollectionSubMapSubI IloAnyCollectionSubMapSubI
#define IloSymbolCollectionSubMapRootI IloAnyCollectionSubMapRootI

ILOSUBMAPHANDLE(IloSymbolCollection, IloSymbolCollectionExprArg)

#define IloTupleSetSubMapExprI IloAnyCollectionSubMapExprI
#define IloTupleSetSubMapSubI IloAnyCollectionSubMapSubI
#define IloTupleSetSubMapRootI IloAnyCollectionSubMapRootI

ILOSUBMAPHANDLE(IloTupleSet, IloTupleSetExprArg)
ILOSUBMAPHANDLE(IloIntCollection, IloIntCollectionExprArg)
ILOSUBMAPHANDLE(IloNumCollection, IloNumCollectionExprArg)

#endif
