// -------------------------------------------------------*- C++ -*----------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_iloanycollexpriH
#define __CONCERT_iloanycollexpriH

#if !defined(__CONCERT_iloforallbaseH)
# include <ilconcert/iloforallbase.h>
#endif



#define IloAnyCollectionExprArgI IloAnyExprI
#define IloAnyCollectionExprI IloAnyExprI

#define IloSymbolCollectionExprI IloAnyCollectionExprI

class IloTupleIndexI;

class IloSymbolCollectionExprGeneratorI;

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionIndexI </p>
**/ 
class IloSymbolCollectionIndexI : public IloSymbolExprI {
  ILOEXTRDECL
  void visitSubExtractables(IloExtractableVisitor* v);
  virtual IloBool hasNongroundType() const;
public:
	virtual IloEncoderI* getEncoder() const;
  IloSymbolCollectionIndexI(IloEnvI* env, const char* name=0); 
  virtual ~IloSymbolCollectionIndexI();
  IloInt getKey() const;
  virtual void errorNotSubstituted() const;
  /* IloSymbolGeneratorI* within(IloSymbolCollectionI* coll) const; */
  IloNum eval(const IloAlgorithm alg) const;
  ILOEXTROTHERDECL 
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionTupleCellIndexI </p>
**/
class IloSymbolCollectionTupleCellExprI : public IloSymbolCollectionExprI {
	ILOEXTRDECL
private:
	IloTupleExprI* _tuple;
	IloInt _colIndex;
	IloSymbolI* _colName;
	void visitSubExtractables(IloExtractableVisitor* v);
public:
	virtual IloEncoderI* getEncoder() const;
	/** <p> . </p> **/
	IloSymbolCollectionTupleCellExprI(IloEnvI* env, IloTupleExprI* tuple, IloInt colIndex);
	/** <p> . </p> **/
	IloSymbolCollectionTupleCellExprI(IloEnvI* env, IloTupleExprI* tuple, IloSymbolI* colName);
  /* <p> . </p> */
  virtual ~IloSymbolCollectionTupleCellExprI();
	/** <p> . </p> **/
	IloTupleExprI* getTuple() const { return _tuple; }
	/** <p> . </p> **/
	IloInt getColumnIndex() const { return _colIndex; }
	/** <p> . </p> */
	IloSymbolI* getColumnName() const { return _colName; }
	/** <p> . </p> */
	/* virtual IloAny eval(IloModelEvaluatorI* e) const; */
	ILOEXTROTHERDECL
};

/** 
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionExprGeneratorI </p>
**/
class IloSymbolCollectionExprGeneratorI : public IloAnyGeneratorI {
	ILOEXTRDECL
private:
	IloSymbolCollectionExprArgI* _coll;
	void visitSubExtractables(IloExtractableVisitor* v);
public:
	/** <p> . </p> */
	IloSymbolCollectionExprGeneratorI(IloEnvI* env, IloAnyIndexI* x, IloSymbolCollectionExprArgI* expr);
	/** <p> . </p> */
	IloSymbolCollectionExprArgI* getCollection() const { return _coll; }
	/** <p> . </p> */
	virtual IloBool generatesDuplicates() const;
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloEvalAnyCollectionExprIIterator </p>
**/
class IloEvalAnyCollectionExprI;
class IloEvalAnyCollectionExprIIterator : public IloAnyDefaultDataIterator {
	IloEvalAnyCollectionExprI*  _expr;
public:
	/** <p> . </p> **/
	IloEvalAnyCollectionExprIIterator(IloGenAlloc* heap, 
		IloEvalAnyCollectionExprI* expr);
	/** <p> . </p> **/
	virtual ~IloEvalAnyCollectionExprIIterator();
	/* <p> . </p> */
	//virtual IloBool next();
	virtual void reset(IloBool catchInvalidCollection = IloFalse);
	virtual void reset(IloAny value, IloBool catchInvalidCollection = IloFalse);
};	

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionTupleCellExprIIterator </p>
**/
class IloSymbolCollectionTupleCellExprIIterator : public IloAnyDefaultDataIterator {
	IloSymbolCollectionTupleCellExprI*  _expr;
	IloModelEvaluatorI* _evaluator;
public:
	/** <p> . </p> **/
	IloSymbolCollectionTupleCellExprIIterator(IloGenAlloc* heap, 
		const IloSymbolCollectionTupleCellExprI* rangeexpr, 
		const IloModelEvaluatorI* eval);
	/** <p> . </p> **/
	virtual ~IloSymbolCollectionTupleCellExprIIterator();
	/* <p> . </p> */
	//virtual IloBool next();
	virtual void reset(IloBool catchInvalidCollection = IloFalse);
	virtual void reset(IloAny value, IloBool catchInvalidCollection = IloFalse);
};	



/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionIndexIIterator </p>
**/
class IloSymbolCollectionIndexIIterator : public IloAnyDefaultDataIterator {
	IloSymbolCollectionIndexI*  _expr;
	IloModelEvaluatorI* _evaluator;
public:
	/** <p> . </p> **/
	IloSymbolCollectionIndexIIterator(IloGenAlloc* heap, 
		const IloSymbolCollectionIndexI* rangeexpr, 
		const IloModelEvaluatorI* eval);
	/** <p> . </p> **/
	virtual ~IloSymbolCollectionIndexIIterator();
	/* <p> . </p> */
	//virtual IloBool next();
	virtual void reset(IloBool catchInvalidCollection = IloFalse);
	virtual void reset(IloAny value, IloBool catchInvalidCollection = IloFalse);
};	


class IloAnyCollectionSubMapExprI;
/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionIndexIIterator </p>
**/
class IloAnyCollectionSubMapExprIIterator : public IloAnyDefaultDataIterator {
	const IloAnyCollectionSubMapExprI*  _expr;
	IloModelEvaluatorI* _evaluator;
public:
	/** <p> . </p> **/
	IloAnyCollectionSubMapExprIIterator(IloGenAlloc* heap, 
		const IloAnyCollectionSubMapExprI* map, 
		const IloModelEvaluatorI* eval);
	/** <p> . </p> **/
	virtual ~IloAnyCollectionSubMapExprIIterator();
	/* <p> . </p> */
	//virtual IloBool next();
	virtual void reset(IloBool catchInvalidCollection = IloFalse);
	virtual void reset(IloAny value, IloBool catchInvalidCollection = IloFalse);
};	




/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolAggregateSetExprI </p>
**/
class IloSymbolAggregateSetExprI : public IloSymbolCollectionExprArgI {
	ILOEXTRDECL
	IloExtendedComprehensionI* _comp;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	// no need to lock e, this is done in the comprehension.
	IloSymbolAggregateSetExprI(IloEnvI* env, IloSymbolExprI* e, IloGeneratorArray g);
	IloSymbolAggregateSetExprI(IloExtendedComprehensionI* comp);

	virtual ~IloSymbolAggregateSetExprI();
	
	  IloExtendedComprehensionI* getComprehension() const { return _comp; }

	  IloSymbolExprI* getBody() const { return (IloSymbolExprI*)_comp->getExtent(); }
	  virtual IloEncoderI* getEncoder() const{ return getEnv()->getSymbolEncoder(); }
	ILOEXTROTHERDECL
};
//


/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolAggregateSetExprI </p>
**/
class IloTupleAggregateSetExprI : public IloTupleSetExprArgI {
	ILOEXTRDECL
	IloExtendedComprehensionI* _comp;
	IloTupleSchemaI* _schema;
	IloBool _hasReference;
	IloIntArray _idx;
	IloArray<IloDiscreteDataCollectionI*> _references;

	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	// no need to lock e, this is done in the comprehension.
	IloTupleAggregateSetExprI(IloEnvI* env, IloTupleSchemaI* schema, IloTupleExprI* e, IloGeneratorArray g);
	IloTupleAggregateSetExprI(IloTupleSchemaI* schema, IloExtendedComprehensionI* comp);
	void setReferences(IloIntArray idx, IloArray<IloDiscreteDataCollectionI*> references);
	IloBool hasReference() const { return _hasReference;}
	IloIntArray getReferenceIndexes() const{ return _idx;}
	IloArray<IloDiscreteDataCollectionI*> getReferences() const{ return _references;}

	virtual ~IloTupleAggregateSetExprI();
	
	  IloExtendedComprehensionI* getComprehension() const { return _comp; }

	  IloTupleSchemaI* getSchema() const { return _schema; }
    void setSchema(IloTupleSchemaI* schema) { _schema = schema; }
	  IloSymbolExprI* getBody() const { return (IloSymbolExprI*)_comp->getExtent(); }
	  virtual IloEncoderI* getEncoder() const{ return getEnv()->getSymbolEncoder(); }
	ILOEXTROTHERDECL
};



#endif
