// -------------------------------------------------------*- C++ -*----------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollexpriH
#define __CONCERT_ilocollexpriH

#if !defined(__CONCERT_iloforallbaseH)
# include <ilconcert/iloforallbase.h>
#endif
#if !defined(__CONCERT_ilotupleH)
# include <ilconcert/ilotuple.h>
#endif
#if !defined(__CONCERT_iloforalliH)
# include <ilconcert/iloforalli.h>
#endif
 
#if !defined(__CONCERT_ilointcollexpriH)
# include <ilconcert/ilocollexpr/ilointcollexpri.h>
#endif
#if !defined(__CONCERT_ilonumcollexpriH)
# include <ilconcert/ilocollexpr/ilonumcollexpri.h>
#endif
#if !defined(__CONCERT_iloanycollexpriH)
# include <ilconcert/ilocollexpr/iloanycollexpri.h>
#endif


//--------------------------------------------------------------
/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionCardI </p>
**/
class IloIntCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionCardI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionCardI();
	/* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionMinI </p>
**/
class IloIntCollectionMinI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionMinI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionMinI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionMaxI </p>
**/
class IloIntCollectionMaxI : public IloIntExprI {
	ILOEXTRDECL
		IloIntCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloIntCollectionMaxI(IloEnvI* env, IloIntCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionMaxI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntExprI* getExpr() const { return _expr; }
};

//-----------------------------------------------------------------------

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionCardI </p>
**/
class IloNumCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloNumCollectionCardI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionCardI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionMinI </p>
**/
class IloNumCollectionMinI : public IloNumExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionMinI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionMinI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionMaxI </p>
**/
class IloNumCollectionMaxI : public IloNumExprI {
	ILOEXTRDECL
		IloNumCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionMaxI(IloEnvI* env, IloNumCollectionExprArgI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionMaxI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumExprI* getExpr() const { return _expr; }
};


//------------------------------------------

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloSymbolCollectionCardI </p>
**/
class IloSymbolCollectionCardI : public IloIntExprI {
	ILOEXTRDECL
		IloSymbolCollectionExprArgI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloSymbolCollectionCardI(IloEnvI* env, IloSymbolCollectionExprArgI* expr) :
	  IloIntExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionCardI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloAnyExprI* getExpr() const { return _expr; }
};



/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionExprMemberI </p>
**/
class IloIntCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloIntExprI* _exp;
	IloIntCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloIntCollectionExprMemberI(IloEnvI* env, IloIntExprI* exp, IloIntCollectionExprArgI* coll);
	/* <p> . </p> */
	virtual ~IloIntCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloIntExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloIntCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionExprMemberI </p>
**/
class IloNumCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloNumExprI* _exp;
	IloNumCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloNumCollectionExprMemberI(IloEnvI* env, IloNumExprI* exp, IloNumCollectionExprArgI* coll);
	/* <p> . </p> */
	virtual ~IloNumCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloNumExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloNumCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};


/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloAnyCollectionExprMemberI </p>
**/
class IloAnyCollectionExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloAnyExprI* _exp;
	IloAnyCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloAnyCollectionExprMemberI(IloEnvI* env, IloAnyExprI* exp, IloAnyCollectionExprArgI* coll);
	virtual ~IloAnyCollectionExprMemberI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloAnyExprI* getExpr() const { return _exp; }
	/* <p> . </p> */
	IloAnyCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionExprMemberCstI </p>
**/
class IloIntCollectionExprMemberCstI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloInt _val;
	IloIntCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloIntCollectionExprMemberCstI(IloEnvI* env, IloInt val, IloIntCollectionExprArgI* coll);
	virtual ~IloIntCollectionExprMemberCstI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloInt getValue() const { return _val; }
	/* <p> . </p> */
	IloIntCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionExprMemberCstI </p>
**/
class IloNumCollectionExprMemberCstI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloNum _val;
	IloNumCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloNumCollectionExprMemberCstI(IloEnvI* env, IloNum val, IloNumCollectionExprArgI* coll);
	virtual ~IloNumCollectionExprMemberCstI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloNum getValue() const { return _val; }
	/* <p> . </p> */
	IloNumCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloAnyCollectionExprMemberCstI </p>
**/
class IloAnyCollectionExprMemberCstI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloAny _val;
	IloAnyCollectionExprArgI* _coll;
public:
	/* <p> . </p> */
	IloAnyCollectionExprMemberCstI(IloEnvI* env, IloAny val, IloAnyCollectionExprArgI* coll);
	virtual ~IloAnyCollectionExprMemberCstI();
	/* <p> . </p> */
	void visitSubExtractables(IloExtractableVisitor* v);
	/* <p> . </p> */
	IloAny getValue() const { return _val; }
	/* <p> . </p> */
	IloAnyCollectionExprArgI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};


//
/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloIntOrdI </p> **/
class IloIntCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloIntCollectionExprI* _coll;
  IloIntExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionOrdI(IloEnvI* env, IloIntCollectionExprI* coll, IloIntExprI* expr) : 
    IloIntExprI(env), _coll(coll->intLockExpr()), _expr(expr->intLockExpr()) {}
  virtual ~IloIntCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloIntCollectionExprI* getCollection() const { return _coll; }
  IloIntExprI* getExpr() const { return _expr; }
};

/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloNumOrdI </p> **/
class IloNumCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloNumCollectionExprI* _coll;
  IloNumExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionOrdI(IloEnvI* env, IloNumCollectionExprI* coll, IloNumExprI* expr) : 
    IloIntExprI(env), _coll(coll->lockExpr()), _expr(expr->lockExpr()) {}
  virtual ~IloNumCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloNumCollectionExprI* getCollection() const { return _coll; }
  IloNumExprI* getExpr() const { return _expr; }
};


/**
 * @group optim.concert.adv
 * @show internal
 * <p> IloSymbolOrdI </p> **/
class IloSymbolCollectionOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloAnyCollectionExprI* _coll;
  IloAnyExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloSymbolCollectionOrdI(IloEnvI* env, IloAnyCollectionExprI* coll, IloAnyExprI* expr) : 
    IloIntExprI(env), _coll(coll->lockExpr()), _expr(expr->lockExpr()) {}
  virtual ~IloSymbolCollectionOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloAnyCollectionExprI* getCollection() const { return _coll; }
  IloAnyExprI* getExpr() const { return _expr; }
};




/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionFirstI </p>
**/
class IloIntCollectionFirstI : public IloIntExprI {
	ILOEXTRDECL
	IloIntCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloIntCollectionFirstI(IloEnvI* env, IloIntCollectionExprI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionFirstI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntCollectionExprArgI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionFirstI </p>
**/
class IloNumCollectionFirstI : public IloNumExprI {
	ILOEXTRDECL
	IloNumCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionFirstI(IloEnvI* env, IloNumCollectionExprI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionFirstI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumCollectionExprArgI* getExpr() const { return _expr; }
};





/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloIntCollectionLastI </p>
**/
class IloIntCollectionLastI : public IloIntExprI {
	ILOEXTRDECL
	IloIntCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public: 
	/* <p> . </p> */
	IloIntCollectionLastI(IloEnvI* env, IloIntCollectionExprI* expr) :
	  IloIntExprI(env), _expr(expr->intLockExpr()) {}
	  virtual ~IloIntCollectionLastI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloIntCollectionExprArgI* getExpr() const { return _expr; }
};

/**
*  @group optim.concert.collexpr
*  @show internal
*  <p> IloNumCollectionLastI </p>
**/
class IloNumCollectionLastI : public IloNumExprI {
	ILOEXTRDECL
	IloNumCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	/* <p> . </p> */
	IloNumCollectionLastI(IloEnvI* env, IloNumCollectionExprI* expr) :
	  IloNumExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloNumCollectionLastI();
	  /* <p> . </p> */
	  void display(ILOSTD(ostream)& out) const;
	  /* <p> . </p> */
	  virtual IloNum eval(const IloAlgorithm alg) const;
	  /* <p> . </p> */
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  /* <p> . </p> */
	  IloNumCollectionExprArgI* getExpr() const { return _expr; }
};



/**
* @group optim.concert.adv
* @show internal
* <p> IloSymbolArray </p>
*/
class IloSymbolCollectionFirstI : public IloSymbolExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloSymbolCollectionFirstI(IloEnvI* env, IloAnyCollectionExprI* expr):
	  IloSymbolExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionFirstI();
	  void display(ILOSTD(ostream)& out) const;
	  IloAnyCollectionExprI* getExpr() const { return _expr; }
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  virtual IloEncoderI* getEncoder() const {
		  return getEnv()->getSymbolEncoder();
	  }
};



/**
* @group optim.concert.adv
* @show internal
* <p> IloSymbolArray </p>
*/
class IloSymbolCollectionLastI : public IloSymbolExprI {
	ILOEXTRDECL
private:
	IloAnyCollectionExprI* _expr;
	virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	IloSymbolCollectionLastI(IloEnvI* env, IloAnyCollectionExprI* expr):
	  IloSymbolExprI(env), _expr(expr->lockExpr()) {}
	  virtual ~IloSymbolCollectionLastI();
	  void display(ILOSTD(ostream)& out) const;
	  IloAnyCollectionExprI* getExpr() const { return _expr; }
	  virtual IloExtractableI* makeClone(IloEnvI*) const;
	  virtual IloEncoderI* getEncoder() const {
		  return getEnv()->getSymbolEncoder();
	  }
};





//---------------------------------------------------------------------------
//   IloIntCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionUnionI. </p> **/
class IloIntCollectionUnionI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionUnionI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionUnionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionUnionI. </p> **/
class IloNumCollectionUnionI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionUnionI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionUnionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionUnion
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionUnionI. </p> **/
class IloAnyCollectionUnionI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionUnionI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionUnionI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionUnionCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionUnionCstI. </p> **/
class IloIntCollectionUnionCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntSetI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionUnionCstI(IloEnvI* env, IloIntSetI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionUnionCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntSetI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionUnionCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionUnionCstI. </p> **/
class IloNumCollectionUnionCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumSetI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionUnionCstI(IloEnvI* env, IloNumSetI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionUnionCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumSetI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionUnionCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionUnionCstI. </p> **/
class IloAnyCollectionUnionCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnySetI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionUnionCstI(IloEnvI* env, IloAnySetI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionUnionCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnySetI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionUnionRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionRecUnionCstI. </p> **/
class IloIntCollectionRecUnionCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionRecUnionCstI(IloEnvI* env, IloIntCollectionExprI* left, IloIntSetI* right);
  virtual ~IloIntCollectionRecUnionCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionUnionRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionRecUnionCstI. </p> **/
class IloNumCollectionRecUnionCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionRecUnionCstI(IloEnvI* env, IloNumCollectionExprI* left, IloNumSetI* right);
  virtual ~IloNumCollectionRecUnionCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionUnionRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionRecUnionCstI. </p> **/
class IloAnyCollectionRecUnionCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnySetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionRecUnionCstI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnySetI* right);
  virtual ~IloAnyCollectionRecUnionCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnySetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionSymExcludeI. </p> **/
class IloIntCollectionSymExcludeI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionSymExcludeI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionSymExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionSymExcludeI. </p> **/
class IloNumCollectionSymExcludeI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionSymExcludeI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionSymExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionSymExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionSymExcludeI. </p> **/
class IloAnyCollectionSymExcludeI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionSymExcludeI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionSymExcludeI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionSymExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionSymExcludeCstI. </p> **/
class IloIntCollectionSymExcludeCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntSetI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionSymExcludeCstI(IloEnvI* env, IloIntSetI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionSymExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntSetI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionSymExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionSymExcludeCstI. </p> **/
class IloNumCollectionSymExcludeCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumSetI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionSymExcludeCstI(IloEnvI* env, IloNumSetI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionSymExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumSetI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionSymExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionSymExcludeCstI. </p> **/
class IloAnyCollectionSymExcludeCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnySetI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionSymExcludeCstI(IloEnvI* env, IloAnySetI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionSymExcludeCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnySetI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionSymExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionRecSymExcludeCstI. </p> **/
class IloIntCollectionRecSymExcludeCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionRecSymExcludeCstI(IloEnvI* env, IloIntCollectionExprI* left, IloIntSetI* right);
  virtual ~IloIntCollectionRecSymExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionSymExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionRecSymExcludeCstI. </p> **/
class IloNumCollectionRecSymExcludeCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionRecSymExcludeCstI(IloEnvI* env, IloNumCollectionExprI* left, IloNumSetI* right);
  virtual ~IloNumCollectionRecSymExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionSymExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionRecSymExcludeCstI. </p> **/
class IloAnyCollectionRecSymExcludeCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnySetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionRecSymExcludeCstI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnySetI* right);
  virtual ~IloAnyCollectionRecSymExcludeCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnySetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionExcludeI. </p> **/
class IloIntCollectionExcludeI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionExcludeI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionExcludeI. </p> **/
class IloNumCollectionExcludeI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionExcludeI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionExcludeI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionExclude
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionExcludeI. </p> **/
class IloAnyCollectionExcludeI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionExcludeI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionExcludeI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionExcludeCstI. </p> **/
class IloIntCollectionExcludeCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntSetI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionExcludeCstI(IloEnvI* env, IloIntSetI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntSetI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionExcludeCstI. </p> **/
class IloNumCollectionExcludeCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumSetI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionExcludeCstI(IloEnvI* env, IloNumSetI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumSetI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionExcludeCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionExcludeCstI. </p> **/
class IloAnyCollectionExcludeCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnySetI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionExcludeCstI(IloEnvI* env, IloAnySetI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionExcludeCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnySetI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionRecExcludeCstI. </p> **/
class IloIntCollectionRecExcludeCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionRecExcludeCstI(IloEnvI* env, IloIntCollectionExprI* left, IloIntSetI* right);
  virtual ~IloIntCollectionRecExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionRecExcludeCstI. </p> **/
class IloNumCollectionRecExcludeCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionRecExcludeCstI(IloEnvI* env, IloNumCollectionExprI* left, IloNumSetI* right);
  virtual ~IloNumCollectionRecExcludeCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionExcludeRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionRecExcludeCstI. </p> **/
class IloAnyCollectionRecExcludeCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnySetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionRecExcludeCstI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnySetI* right);
  virtual ~IloAnyCollectionRecExcludeCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnySetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionInterI. </p> **/
class IloIntCollectionInterI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionInterI(IloEnvI* env, IloIntCollectionExprI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionInterI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionInterI. </p> **/
class IloNumCollectionInterI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionInterI(IloEnvI* env, IloNumCollectionExprI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionInterI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionInter
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionInterI. </p> **/
class IloAnyCollectionInterI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionInterI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionInterI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



//---------------------------------------------------------------------------
//   IloIntCollectionInterCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionInterCstI. </p> **/
class IloIntCollectionInterCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntSetI* _left;
  IloIntCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionInterCstI(IloEnvI* env, IloIntSetI* left, IloIntCollectionExprI* right);
  virtual ~IloIntCollectionInterCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntSetI* getLeft() const { return _left;}
  IloIntCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionInterCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionInterCstI. </p> **/
class IloNumCollectionInterCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumSetI* _left;
  IloNumCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionInterCstI(IloEnvI* env, IloNumSetI* left, IloNumCollectionExprI* right);
  virtual ~IloNumCollectionInterCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumSetI* getLeft() const { return _left;}
  IloNumCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionInterCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionInterCstI. </p> **/
class IloAnyCollectionInterCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnySetI* _left;
  IloAnyCollectionExprI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionInterCstI(IloEnvI* env, IloAnySetI* left, IloAnyCollectionExprI* right);
  virtual ~IloAnyCollectionInterCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnySetI* getLeft() const { return _left;}
  IloAnyCollectionExprI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


//---------------------------------------------------------------------------
//   IloIntCollectionInterRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionRecInterCstI. </p> **/
class IloIntCollectionRecInterCstI : public IloIntCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _left;
  IloIntSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionRecInterCstI(IloEnvI* env, IloIntCollectionExprI* left, IloIntSetI* right);
  virtual ~IloIntCollectionRecInterCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getLeft() const { return _left;}
  IloIntSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};

//---------------------------------------------------------------------------
//   IloNumCollectionInterRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloNumCollectionRecInterCstI. </p> **/
class IloNumCollectionRecInterCstI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloNumCollectionExprI* _left;
  IloNumSetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumCollectionRecInterCstI(IloEnvI* env, IloNumCollectionExprI* left, IloNumSetI* right);
  virtual ~IloNumCollectionRecInterCstI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloNumCollectionExprI* getLeft() const { return _left;}
  IloNumSetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};
//---------------------------------------------------------------------------
//   IloAnyCollectionInterRecCst
//---------------------------------------------------------------------------
/**
 * @group optim.concert.map
 * @show internal
 * <p> IloAnyCollectionRecInterCstI. </p> **/
class IloAnyCollectionRecInterCstI : public IloAnyCollectionExprI {
  ILOEXTRDECL
private:
  IloAnyCollectionExprI* _left;
  IloAnySetI* _right;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloAnyCollectionRecInterCstI(IloEnvI* env, IloAnyCollectionExprI* left, IloAnySetI* right);
  virtual ~IloAnyCollectionRecInterCstI();
  virtual IloEncoderI* getEncoder() const;
  IloAnyCollectionExprI* getLeft() const { return _left;}
  IloAnySetI* getRight() const { return _right;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};



/**
 * @group optim.concert.map
 * @show internal
 * <p> IloIntCollectionAsNumCollectionI. </p> **/
class IloIntCollectionAsNumCollectionI : public IloNumCollectionExprI {
  ILOEXTRDECL
private:
  IloIntCollectionExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntCollectionAsNumCollectionI(IloEnvI* env, IloIntCollectionExprI* left);
  virtual ~IloIntCollectionAsNumCollectionI();
  virtual IloNum eval(const IloAlgorithm alg) const;
  IloIntCollectionExprI* getExpr() const { return _expr;}
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  void display(ILOSTD(ostream)& out) const;
};


#endif
