// -------------------------------------------------------*- C++ -*----------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilocollexprbaseH
#define __CONCERT_ilocollexprbaseH

#ifndef __CONCERT_iloanyH
#include <ilconcert/iloany.h>
#endif

#ifndef __CONCERT_iloanyexpriH
#include <ilconcert/iloanyexpri.h>
#endif
#ifndef __CONCERT_ilocollectionH
#include <ilconcert/ilocollection.h>
#endif
#if !defined(__CONCERT_iloforallH)
#include <ilconcert/iloforall.h>
#endif
#ifndef __CONCERT_ilocollexpriH
#include <ilconcert/ilocollexpr/ilocollexpri.h>
#endif

class IloIntCollectionExprGenerator;
class IloNumCollectionExprGenerator;
class IloSymbolCollectionExprGenerator;



//-----------------------------------------------------------------
class ILO_EXPORTED IloIntCollectionExprArg : public IloExtractable {
	ILOEXTRHANDLE(IloIntCollectionExprArg, IloExtractable)
public:
	IloIntCollectionExprArg(IloIntSubMapExpr handle);
	IloIntCollectionExprArg(IloIntExprArg lb, IloIntExprArg ub);
	IloIntCollectionExprArg(IloIntExprArg lb, IloInt ub);
	IloIntCollectionExprArg(IloInt lb, IloIntExprArg ub);
};

class ILO_EXPORTED IloNumCollectionExprArg : public IloExtractable {
	ILOEXTRHANDLE(IloNumCollectionExprArg, IloExtractable)
public:
	IloNumCollectionExprArg(IloNumSubMapExpr handle);
	IloNumCollectionExprArg(IloNumExprArg lb, IloNumExprArg ub);
	IloNumCollectionExprArg(IloNumExprArg lb, IloNum ub);
	IloNumCollectionExprArg(IloNum lb, IloNumExprArg ub);
};

class ILO_EXPORTED IloAnyCollectionExprArg : public IloExtractable {
	ILOEXTRHANDLE(IloAnyCollectionExprArg, IloExtractable)
};

class ILO_EXPORTED IloSymbolCollectionExprArg : public IloAnyCollectionExprArg {
	ILOEXTRHANDLE(IloSymbolCollectionExprArg, IloAnyCollectionExprArg)
public:
	IloSymbolCollectionExprArg(IloSymbolSubMapExpr handle);
};

class IloIntCollectionIndex : public IloIntCollectionExprArg {
	ILOEXTRHANDLE(IloIntCollectionIndex, IloIntCollectionExprArg)
public:
	/* <p> . </p> */
	IloIntCollectionIndex(IloEnv env, const char* name=0);

	class NotSubstituted : public IloException {
	private:
		const IloIntCollectionIndexI* _idx;
	public:
		NotSubstituted(const IloIntCollectionIndexI* idx);
		NotSubstituted(const IloIntCollectionIndex idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
	class TupleCellGenerator : public IloException {
	private:
		const IloIntCollectionIndexI* _idx;
	public:
		TupleCellGenerator(const IloIntCollectionIndexI* idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
};
//--------------------------

class IloNumCollectionIndex : public IloNumCollectionExprArg {
	ILOEXTRHANDLE(IloNumCollectionIndex, IloNumCollectionExprArg)
public:
	/* <p> . </p> */
	IloNumCollectionIndex(IloEnv env, const char* name=0);

	class NotSubstituted : public IloException {
	private:
		const IloNumCollectionIndexI* _idx;
	public:
		NotSubstituted(const IloNumCollectionIndexI* idx);
		NotSubstituted(const IloNumCollectionIndex idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
	class TupleCellGenerator : public IloException {
	private:
		const IloNumCollectionIndexI* _idx;
	public:
		TupleCellGenerator(const IloNumCollectionIndexI* idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
};


class IloSymbolCollectionIndex : public IloSymbolCollectionExprArg {
	ILOEXTRHANDLE(IloSymbolCollectionIndex, IloSymbolCollectionExprArg)
public:
	/* <p> . </p> */
	IloSymbolCollectionIndex(IloEnv env, const char* name=0);

	class NotSubstituted : public IloException {
	private:
		const IloSymbolCollectionIndexI* _idx;
	public:
		NotSubstituted(const IloSymbolCollectionIndexI* idx);
		NotSubstituted(const IloSymbolCollectionIndex idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
	class TupleCellGenerator : public IloException {
	private:
		const IloSymbolCollectionIndexI* _idx;
	public:
		TupleCellGenerator(const IloSymbolCollectionIndexI* idx);
		virtual const char* getMessage() const;
		void print(ILOSTD(ostream)& out) const;
	};
};

#endif
