// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __CONCERT_ilomemberH
#define __CONCERT_ilomemberH

#if !defined(__CONCERT_iloenvH)
#include <ilconcert/iloenv.h>
#endif
#if !defined(__CONCERT_ilomodelH)
#include <ilconcert/ilomodel.h>
#endif

#if !defined(__CONCERT_ilocollectionH)
#include <ilconcert/ilocollection.h>
#endif
#if !defined(__CONCERT_ilotuplecollectionH)
#include <ilconcert/ilotuplecollection.h>
#endif
#if !defined(__CONCERT_ilotupleH)
#include <ilconcert/ilotuple.h>
#endif

/////////////////
//
//  Constraints
//
class IloSymbolExprArg;
class IloTupleExprArg;
class IloTupleSet;
class IloAnyExprI;

IloConstraint IloMember(const IloEnv env, const IloIntExprArg exp, const IloIntCollection s);

IloConstraint IloMember(const IloEnv env, const IloNumExprArg exp, const IloNumCollection s);

IloConstraint IloMember(const IloEnv env, const IloSymbolExprArg exp, const IloAnyCollection s);

IloConstraint IloMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSet s);

IloConstraint IloMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSetExprArg s);

IloConstraint IloMember(const IloEnv env, const IloSymbolExprArg expr, const IloSymbolArray elements);


IloConstraint IloNotMember(const IloEnv env, const IloIntExprArg exp, const IloIntCollection s);

IloConstraint IloNotMember(const IloEnv env, const IloNumExprArg exp, const IloNumCollection s);

IloConstraint IloNotMember(const IloEnv env, const IloSymbolExprArg exp, const IloAnyCollection s);

IloConstraint IloNotMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSet s);

IloConstraint IloNotMember(const IloEnv env, const IloTupleExprArg exp, const IloTupleSetExprArg s);

IloConstraint IloNotMember(const IloEnv env, const IloIntExprArg expr, const IloIntArray elements);

IloConstraint IloNotMember(const IloEnv env, const IloNumExprArg expr, const IloNumArray elements);

IloConstraint IloNotMember(const IloEnv env, const IloSymbolExprArg expr, const IloSymbolArray elements);

class IloIntCollectionMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloIntExprI* _exp;
	IloIntCollectionI* _coll;
public:
	IloIntCollectionMemberI(IloEnvI* env, IloIntExprI* exp, IloIntCollectionI* coll);
	virtual ~IloIntCollectionMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloIntExprI* getExpr() const { return _exp; }
	IloIntCollectionI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

class IloNumCollectionMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloNumExprI* _exp;
	IloNumCollectionI* _coll;
public:
	IloNumCollectionMemberI(IloEnvI* env, IloNumExprI* exp, IloNumCollectionI* coll);
	virtual ~IloNumCollectionMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloNumExprI* getExpr() const { return _exp; }
	IloNumCollectionI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};


class IloAnyCollectionMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloAnyExprI* _exp;
	IloAnyCollectionI* _coll;
public:
	IloAnyCollectionMemberI(IloEnvI* env, IloAnyExprI* exp, IloAnyCollectionI* coll);
    virtual ~IloAnyCollectionMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloAnyExprI* getExpr() const { return _exp; }
	IloAnyCollectionI* getCollection() const { return _coll; }
	ILOEXTROTHERDECL
};

class IloTupleSetMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloTupleExprArgI* _exp;
	IloTupleSetI* _coll;
public:
	IloTupleSetMemberI(IloEnvI* env, IloTupleExprArgI* exp, IloTupleSetI* coll);
    virtual ~IloTupleSetMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloTupleExprArgI* getExpr() const { return _exp; }
	IloTupleSetI* getTupleSet() const { return _coll; }
	ILOEXTROTHERDECL
};


class IloTupleSetExprMemberI : public IloConstraintI {
	ILOEXTRDECL
private:
	IloTupleExprArgI* _exp;
	IloTupleSetExprArgI* _coll;
public:
	IloTupleSetExprMemberI(IloEnvI* env, IloTupleExprArgI* exp, IloTupleSetExprArgI* coll);
    virtual ~IloTupleSetExprMemberI();
	void visitSubExtractables(IloExtractableVisitor* v);
	IloTupleExprArgI* getTupleExpr() const { return _exp; }
	IloTupleSetExprArgI* getTupleSetExpr() const { return _coll; }
	ILOEXTROTHERDECL
};


class IloAnyArrayMemberI : public IloConstraintI {
	ILOEXTRMEMBERS2DECL(IloAnyArrayMemberI,IloConstraintI,
		IloAnyExprI*, _expr,
		IloAnyArray, _elements)
		virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
	virtual ~IloAnyArrayMemberI();
	IloAnyExprI* getExpr() const {return _expr;}
	IloAnyArray getElements() const {return _elements;}
};

#endif


