// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_iloordH
#define __CONCERT_iloordH

#if !defined(__CONCERT_iloexpressionH)
# include <ilconcert/iloexpression.h>
#endif
#if !defined(__CONCERT_iloanyexpriH)
# include <ilconcert/iloanyexpri.h>
#endif


class IloIntSet;
class IloNumSet;
class IloSymbolSet;
class IloTupleSet;
class IloTuple;

class IloIntSetI;
class IloNumSetI;
class IloAnySetI;
class IloTupleSetI;

class IloSymbolExprArg;
class IloNumExprArg;
class IloSymbolExprArg;
class IloTupleExprArg;

class IloIntExprArg;

IloConstraint IloOrdered(IloNumSet set, IloNumExprArg base, IloNumExprArg base2);
IloConstraint IloOrdered(IloNumSet set, IloNumExprArg base, IloNum val);
IloConstraint IloOrdered(IloNumSet set, IloNum val, IloNumExprArg expr);
IloConstraint IloOrdered(IloIntSet set, IloIntExprArg base, IloIntExprArg base2);
IloConstraint IloOrdered(IloIntSet set, IloIntExprArg base, IloInt val);
IloConstraint IloOrdered(IloIntSet set, IloInt val, IloIntExprArg base);

IloIntExprArg IloOrd (const IloIntSet x, const IloIntExprArg y);
IloIntExprArg IloOrd (const IloNumSet x, const IloNumExprArg y);
IloIntExprArg IloOrd (const IloSymbolSet x, const IloSymbolExprArg y);

IloIntExprArg IloOrd (const IloTupleSet x, const IloTupleExprArg y);

IloInt IloOrd(const IloIntSet x, IloInt y);

IloInt IloOrd(const IloNumSet x, IloNum y);

IloInt IloOrd(const IloSymbolSet x, IloSymbol y);

IloInt IloOrd(const IloTupleSet x, IloTuple y);

IloConstraint IloOrdered(IloTupleSet set, IloTupleExprArg base, IloTupleExprArg base2);

IloConstraint IloOrdered(IloTupleSet set, IloTupleExprArg base, IloTuple val);

IloConstraint IloOrdered(IloTupleSet set, IloTuple val, IloTupleExprArg base);


IloConstraint IloOrdered(IloSymbolSet set, const IloSymbolExprArg expr1, const IloSymbolExprArg expr2);

IloConstraint IloOrdered(IloSymbolSet set, const IloSymbolExprArg expr, const char* value);

IloConstraint IloOrdered(IloSymbolSet set, const char* val, const IloSymbolExprArg expr);

IloConstraint IloOrdered(IloSymbolSet set, const IloSymbolExprArg expr, IloSymbol value);

IloConstraint IloOrdered(IloSymbolSet set, IloSymbol val, const IloSymbolExprArg expr);


//
class IloIntOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloIntSetI* _coll;
  IloIntExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloIntOrdI(IloEnvI* env, IloIntSetI* coll, IloIntExprI* expr) :
    IloIntExprI(env), _coll(coll), _expr(expr->intLockExpr()) {}
  virtual ~IloIntOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloIntSetI* getIntSet() const { return _coll; }
  IloIntExprI* getIntExpr() const { return _expr; }
};

class IloNumOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloNumSetI* _coll;
  IloNumExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloNumOrdI(IloEnvI* env, IloNumSetI* coll, IloNumExprI* expr) :
    IloIntExprI(env), _coll(coll), _expr(expr->lockExpr()) {}
  virtual ~IloNumOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloNumSetI* getNumSet() const { return _coll; }
  IloNumExprI* getNumExpr() const { return _expr; }
};


class IloSymbolOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloAnySetI* _coll;
  IloAnyExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloSymbolOrdI(IloEnvI* env, IloAnySetI* coll, IloAnyExprI* expr) :
    IloIntExprI(env), _coll(coll), _expr(expr->lockExpr()) {}
  virtual ~IloSymbolOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloAnySetI* getAnySet() const { return _coll; }
  IloAnyExprI* getExpr() const { return _expr; }
};



class IloTupleOrdI : public IloIntExprI {
  ILOEXTRDECL
  IloTupleSetI* _coll;
  IloAnyExprI* _expr;
  virtual void visitSubExtractables(IloExtractableVisitor* v);
public:
  IloTupleOrdI(IloEnvI* env, IloTupleSetI* coll, IloAnyExprI* expr) :
    IloIntExprI(env), _coll(coll), _expr(expr->lockExpr()) {}
  virtual ~IloTupleOrdI();
  void display(ILOSTD(ostream)& out) const;
  virtual IloNum eval(const IloAlgorithm alg) const;
  virtual IloExtractableI* makeClone(IloEnvI*) const;
  IloTupleSetI* getTupleSet() const { return _coll; }
  IloAnyExprI* getExpr() const { return _expr; }
};

#endif
