// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_iloshareddomainiH
#define __CONCERT_iloshareddomainiH

#if !defined(__CONCERT_ilodomainiH)
# include <ilconcert/ilodomaini.h>
#endif

#if !defined(__CONCERT_ilohashH)
# include <ilconcert/ilohash.h>
#endif




class IloNumSharedVarDomainI : public IloNumVarDomainI {
public:
	//IloNumVarDomainI(const IloNumCollectionI* coll) : IloNumVarDomain(coll){}
	IloNumSharedVarDomainI(const IloNumRangeI* coll) : IloNumVarDomainI(coll){}
	IloNumSharedVarDomainI(IloNum lb, IloNum ub) : IloNumVarDomainI(lb, ub){}
	//IloNumVarDomainI(IloNumArray ar) : IloNumVarDomain(ar){}
	virtual IloBool isShared() const{ return IloTrue; }
	//virtual IloVarDomainI* makeClone(IloEnvI* env);
	virtual ~IloNumSharedVarDomainI(){}
	virtual void suicide(IloEnvI*, void* ptr);
};


class IloIntSharedVarDomainI : public IloIntVarDomainI {
public:
	//IloIntVarDomainI(const IloIntCollectionI* coll);
	IloIntSharedVarDomainI(const IloIntRangeI* coll) : IloIntVarDomainI(coll){}
	//IloIntVarDomainI(const IloAnyCollectionI* coll);

	IloIntSharedVarDomainI(IloInt lb, IloInt ub, IloBool any = IloFalse) : IloIntVarDomainI(lb, ub, any){}
	//IloIntVarDomainI(IloIntArray ar, IloBool any = IloFalse);
	virtual IloBool isShared() const { return IloTrue; }
	//virtual IloVarDomainI* makeClone(IloEnvI* env);
	virtual ~IloIntSharedVarDomainI(){}
	virtual void suicide(IloEnvI*, void* ptr);
};


class IloBoolSharedVarDomainI : public IloBoolVarDomainI {
public:
	IloBoolSharedVarDomainI(IloInt lb=0, IloInt ub=1) : IloBoolVarDomainI(lb, ub){}
	virtual IloBool isShared() const { return IloTrue; }
	//virtual IloVarDomainI* makeClone(IloEnvI* env);
	virtual ~IloBoolSharedVarDomainI(){}
	virtual void suicide(IloEnvI*, void* ptr);
};



template <class KeyType>
class IloSharedDomainHash : public IloEnvHashTable<KeyType, IloVarDomainI*>{
public:
	typedef IloInt (*IloHashFunction) (KeyType, IloInt);
	typedef IloBool (*IloCompFunction) (KeyType, KeyType);

	IloSharedDomainHash(IloEnv env,
		IloHashFunction hashFct,
		IloCompFunction compFct,
		IloInt size=IloDefaultHashSize)
		:IloEnvHashTable<KeyType, IloVarDomainI*>(env, hashFct,compFct, size) {}
		~IloSharedDomainHash(){
		}
};

extern IloInt  IloIntDomainHashFunction(IloIntRangeI*, IloInt size);
extern IloBool IloIntDomainCompFunction(IloIntRangeI* key1, IloIntRangeI* key2);

class IloIntSharedDomainHash : public IloSharedDomainHash<IloIntRangeI*>{
public:
	IloIntSharedDomainHash(IloEnv env, IloInt size=IloDefaultHashSize)
		:IloSharedDomainHash<IloIntRangeI*>(env,
		IloIntDomainHashFunction,
		IloIntDomainCompFunction,
		size) {}
		~IloIntSharedDomainHash(); // doit tuer les range et les shared domains.
};



extern IloInt  IloNumDomainHashFunction(IloNumRangeI*, IloInt size);
extern IloBool IloNumDomainCompFunction(IloNumRangeI* key1, IloNumRangeI* key2);

class IloNumSharedDomainHash : public IloSharedDomainHash<IloNumRangeI*>{
public:
	IloNumSharedDomainHash(IloEnv env, IloInt size=IloDefaultHashSize)
		:IloSharedDomainHash<IloNumRangeI*>(env,
		IloNumDomainHashFunction,
		IloNumDomainCompFunction,
		size) {}
		~IloNumSharedDomainHash(); // doit tuer les range et les shared domains.
};



#endif
