// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilotuplemapH
#define __CONCERT_ilotuplemapH


#if !defined(__CONCERT_ilotuplemapiH)
#include <ilconcert/iltuple/ilotuplemapi.h>
#endif

//const int, const char, const short
#define REDEFINE_GET_SET_INT(_IdxType) \
  void set(_IdxType index, IloTuple value) {\
    this->set((IloInt)index, value);\
  }\
  void set(_IdxType index, IloTupleBuffer value) {\
    this->set((IloInt)index, value);\
  }\
  void get(_IdxType index, IloTuple tuple) const {\
    this->get((IloInt)index, tuple);\
  }\
  void get(_IdxType index, IloTupleBuffer buffer) const {\
    this->get((IloInt)index, buffer);\
  }

/////////////////////////////////////
//
// IloTupleMap
//
// IloInt, IloNum, IloSymbol, IloTuple
#define DEFINE_GET_SET_TO_IMPL(_IdxType) \
  void set(_IdxType index, IloTuple value) {\
    IloAssert (_impl, "Empty Handle in IloTupleMap::set");\
    IloAssert (value.getImpl(), "Empty Handle in IloTupleMap::set");\
    _impl->implSet(index, value);\
  }\
  void set(_IdxType index, IloTupleBuffer value) {\
    IloAssert (_impl, "Empty Handle in IloTupleMap::set");\
    IloAssert (value.getImpl(), "Empty Handle in IloTupleMap::set");\
    _impl->implSet(index, value);\
  }\
  void get(_IdxType index, IloTuple tuple) const {\
    IloAssert (_impl, "Empty Handle in IloTupleMap::fill");\
    IloAssert (tuple.getImpl(), "Empty Handle in IloTupleMap::set");\
    _impl->implGet(index, tuple);\
  }\
  void get(_IdxType index, IloTupleBuffer buffer) const {\
    IloAssert (_impl, "Empty Handle in IloTupleMap::fill");\
    IloAssert (buffer.getImpl(), "Empty Handle in IloTupleMap::set");\
    _impl->implGet(index, buffer);\
  }

class IloTupleMap {
private:
protected:
  IloAbstractTupleMapI* _impl;
public:
  typedef IloAbstractTupleMapI ImplClass;
  IloTupleMap(IloAbstractTupleMapI* impl) : _impl(impl) {}
  IloTupleMap() : _impl(0) {}
  IloAbstractTupleMapI* getImpl() const { return _impl; }
  IloTupleMap(IloEnv env,
	      IloMapIndexer indexer,
	      const IloTupleSchema& schema, IloTupleCellArray defaultValue);
  IloTupleMap(IloEnv env,
	      IloMapIndexer indexer,
	      const IloTupleSchema& schema, IloTupleBuffer defaultValue);
  IloTupleMap(IloEnv env,
	      IloMapIndexer indexer,
	      const IloTupleSchema& schema);
  IloTupleMap(IloEnv env,
	      IloMapIndexer indexer,
	      IloTupleSet s);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer,
	      const IloTupleSchema& schema);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer,
	      IloTupleSet s);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      const IloTupleSchema& schema);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      IloTupleSet s);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      IloDiscreteDataCollection indexer3,
	      const IloTupleSchema& schema);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      IloDiscreteDataCollection indexer3,
	      IloTupleSet s);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      IloDiscreteDataCollection indexer3,
	      IloDiscreteDataCollection indexer4,
	      const IloTupleSchema& schema);
  IloTupleMap(IloEnv env,
	      IloDiscreteDataCollection indexer1,
	      IloDiscreteDataCollection indexer2,
	      IloDiscreteDataCollection indexer3,
	      IloDiscreteDataCollection indexer4,
	      IloTupleSet s);


  void end();
  void endElements();
  IloEnv getEnv() const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getEnv");
    return _impl->getEnv();
  }

  IloDiscreteDataCollection getIndexer() const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getIndexer");
    return IloDiscreteDataCollection(_impl->getIndexer());
  }
  IloDiscreteDataCollection getIndexer(IloInt i) const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getIndexer");
    return IloDiscreteDataCollection(_impl->getIndexer(i));
  }

  IloInt getSize() const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getSize");
    return _impl->getSize();
  }
  IloInt getNbDim() const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getNbDim");
    return _impl->getNbDim();
  }
  IloInt getTotalSize() const {
    IloAssert(_impl, "Empty Handle in IloTupleMap::getTotalSize");
    return _impl->getTotalSize();
  }
  IloMapIndexer makeMapIndexer() const;

  IloAbstractTupleMapI* copy() const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::copy");
    return _impl->getCopy();
  }
  IloAbstractTupleMapI* lock() const {
    if (_impl != 0) _impl->lock();
    return _impl;
  }
  IloAbstractTupleMapI* unlock() const {
    if (_impl != 0) _impl->unlock();
    return _impl;
  }
  IloBool isLocked() const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::isLocked");
    return _impl->isLocked();
  }

  IloTupleBuffer makeTupleBuffer() const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::makeTupleBuffer");
    return _impl->makeTupleBuffer();
  }
  IloTuple makeTuple() const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::makeTuple");
    return _impl->makeTuple();
  }
  const char * getName() const {
    if (getImpl() == 0)
      throw IloEmptyHandleException("IloTupleMap::getName : Using empty handle");
    return getImpl()->getName();
  }
  void setName(const char * name) const {
    if (getImpl() == 0)
      throw IloEmptyHandleException("IloTupleMap::setName : Using empty handle");
    getImpl()->setName(name);
  }

  DEFINE_GET_SET_TO_IMPL(IloInt)
  DEFINE_GET_SET_TO_IMPL(IloNum)
  DEFINE_GET_SET_TO_IMPL(IloSymbol)
  DEFINE_GET_SET_TO_IMPL(IloTuple)
  REDEFINE_GET_SET_INT(const int)
  REDEFINE_GET_SET_INT(const char)
  REDEFINE_GET_SET_INT(const short)

  void set(const char* index, IloTuple value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap1::set");
    IloAssert (getNbDim() == 1,
	       "IloTupleMap::set is not available on multi-dimensional map.");
    this->set(this->getEnv().makeSymbol(index), value);
  }
  void set(const char* index, IloTupleBuffer value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap1::set");
    IloAssert (getNbDim() == 1,
	       "IloTupleMap::set is not available on multi-dimensional map.");
    this->set(this->getEnv().makeSymbol(index), value);
  }
  void get(const char* index, IloTuple tuple) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap1::get");
    IloAssert (getNbDim() == 1,
	       "IloTupleMap::get is not available on multi-dimensional map.");
    this->get(this->getEnv().makeSymbol(index), tuple);
  }
  void get(const char* index, IloTupleBuffer buffer) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap1::get");
    IloAssert (getNbDim() == 1,
	       "IloTupleMap::get is not available on multi-dimensional map.");
    this->get(this->getEnv().makeSymbol(index), buffer);
  }

  void setAt(IloMapIndexArray indices, IloTuple value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap::setAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::setAt number of dimensions mismatch");
    _impl->setAt(indices, value);
  }
  void setAt(IloMapIndexArray indices, IloTupleBuffer value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap::setAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::setAt number of dimensions mismatch");
    _impl->setAt(indices, value);
  }
  void setAt(IloMapIndexArray indices, IloMapItem value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap::setAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::setAt number of dimensions mismatch");
    _impl->setAt(indices, value);
  }
  IloMapItem getAt(IloMapIndexArray indices) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::getAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::getAt number of dimensions mismatch");
    return _impl->getAt(indices);
  }

  void getAt(IloMapIndexArray indices, IloTuple tuple) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::getAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::getAt number of dimensions mismatch");
    _impl->getAt(indices, tuple);
  }
  void getAt(IloMapIndexArray indices, IloTupleBuffer buffer) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::getAt");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::getAt number of dimensions mismatch");
    _impl->getAt(indices, buffer);
  }

  void setAtAbsoluteIndex(IloIntArray indices, IloTuple value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap::setAbsoluteIndex");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::setAtAbsoluteIndex number of dimensions mismatch");
    _impl->setAtAbsoluteIndex(indices, value);
  }
  void setAtAbsoluteIndex(IloIntArray indices, IloTupleBuffer value) {
    IloAssert (_impl, "Empty Handle in IloTupleMap::setAbsoluteIndex");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::setAtAbsoluteIndex number of dimensions mismatch");
    _impl->setAtAbsoluteIndex(indices, value);
  }
  void getAtAbsoluteIndex(IloIntArray indices, IloTuple tuple) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::getAtAbsoluteIndex");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::getAtAbsoluteIndex number of dimensions mismatch");
    _impl->getAtAbsoluteIndex(indices, tuple);
  }

  void getAtAbsoluteIndex(IloIntArray indices, IloTupleBuffer buffer) const {
    IloAssert (_impl, "Empty Handle in IloTupleMap::getAtAbsoluteIndex");
    IloAssert (getNbDim() == indices.getSize(),
	       "IloTupleMap::getAtAbsoluteIndex number of dimensions mismatch");
    _impl->getAtAbsoluteIndex(indices, buffer);
  }

  IloTupleSchema getSchema() const {
    IloAssert(getImpl(), "IloTupleMap::getSchema using empty handle");
    return getImpl()->getSchema();
  }

  DEFINE_EXPR_ACCESSORS(IloTupleSubMapExpr)

  IloBool isDefaultValue(IloTuple tuple){
     IloAssert(getImpl(), "IloTupleMap::isDefaultValue using empty handle");
 	 return getImpl()->isDefaultValue(tuple );
  }
};

#endif
