// -------------------------------------------------------------- -*- C++ -*-
// File: ilconcert/ilodatasourcei.h
// --------------------------------------------------------------------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

// -*- C++ -*- header file.
#ifndef __CONCERT_ilodatasourceiH
#define __CONCERT_ilodatasourceiH

#ifndef __CONCERT_ilocsvreaderH
#include <ilconcert/ilocsvreader.h>
#endif
#ifndef __CONCERT_ilosymbolH
#include <ilconcert/ilosymbol.h>
#endif
#ifndef __CONCERT_iloanysetH
#include <ilconcert/iloanyset.h>
#endif

#ifndef __CONCERT_ilotuplecollectionH
#include <ilconcert/ilotuplecollection.h>
#endif
#ifndef __CONCERT_ilotupleH
#include <ilconcert/ilotuple.h>
#endif


#ifdef ILO_MSVC
#ifndef ILO_WIN64
#ifndef __CONCERT_ilodrvsheetH
#include <ilconcert/ilsource/ilodrvsheet.h>
#endif

#include <stdio.h>
#include <wtypes.h>
#include <comdef.h>
#endif
#endif

class IloCsvTableReaderI;
class IloCsvTableReader;

class IloCsvLineI;

class IloAbstractTupleMapI;


/**
* @group optim.concert.source
* @show internal
*
* <p>String DataSource.</p> 
*/

class IloStringDataSourceI : public IloRttiEnvObjectI{
	ILORTTIDECL
public:
	/** <p> . </p> */
	IloStringDataSourceI(IloEnv env);
	~IloStringDataSourceI();

	/** <p> . </p> */
	IloIntArray getIntArray(const char* str);
	/** <p> . </p> */
	IloNumArray getNumArray(const char* str);
	/** <p> . </p> */
	IloSymbolArray getSymbolArray(const char* str);

	/** <p> . </p> */
	IloIntSet getIntSet(const char* str);
	/** <p> . </p> */
	IloNumSet getNumSet(const char* str);
	/** <p> . </p> */
	IloSymbolSet getSymbolSet(const char* str);

	/** <p> . </p> */
	IloInt getInt(const char* str);
	/** <p> . </p> */
	IloNum getNum(const char* str);
	/** <p> . </p> */
	IloSymbol getSymbol(const char* str);

	/** <p> . </p> */
	IloIntArray2 getIntArray2(const char* str);
	/** <p> . </p> */
	IloNumArray2 getNumArray2(const char* str);
	/** <p> . </p> */
	IloSymbolArray2 getSymbolArray2(const char* str);

	/** <p> . </p> */
	IloIntSetArray getIntSetArray(const char* str);
	/** <p> . </p> */
	IloNumSetArray getNumSetArray(const char* str);
	/** <p> . </p> */
	IloSymbolSetArray getSymbolSetArray(const char* str);
};

/**
* @group optim.concert.source
* @show internal
*
* <p>CSV DataSource.</p> 
*/
class IloCsvDataSourceI : public IloRttiEnvObjectI{
	ILORTTIDECL
private:
	void closeConnexion();
	IloCsvReader _reader;
public:
	/** <p> . </p> */
	IloCsvDataSourceI(IloEnv env, const char* fileName);
	~IloCsvDataSourceI();

	/** <p> . </p> */
	IloIntArray getIntArrayFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloIntArray getIntArrayFromColumn(const char* tableName, IloInt column);
	/** <p> . </p> */
	IloIntSet getIntSetFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloIntSet getIntSetFromColumn(const char* tableName, IloInt column);

	/** <p> . </p> */
	IloNumArray getNumArrayFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloNumArray getNumArrayFromColumn(const char* tableName, IloInt column);
	/** <p> . </p> */
	IloNumSet getNumSetFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloNumSet getNumSetFromColumn(const char* tableName, IloInt column);

	/** <p> . </p> */
	IloSymbolArray getSymbolArrayFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloSymbolArray getSymbolArrayFromColumn(const char* tableName, IloInt column);
	/** <p> . </p> */
	IloSymbolSet getSymbolSetFromLine(const char* tableName, IloInt line);
	/** <p> . </p> */
	IloSymbolSet getSymbolSetFromColumn(const char* tableName, IloInt column);

	/** <p> . </p> */
	IloIntArray getIntArrayFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloIntArray getIntArrayFromColumn(IloInt tableIndex, IloInt column);
	/** <p> . </p> */
	IloIntSet getIntSetFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloIntSet getIntSetFromColumn(IloInt tableIndex, IloInt column);

	/** <p> . </p> */
	IloNumArray getNumArrayFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloNumArray getNumArrayFromColumn(IloInt tableIndex, IloInt column);

	/** <p> . </p> */
	IloNumSet getNumSetFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloNumSet getNumSetFromColumn(IloInt tableIndex, IloInt column);

	/** <p> . </p> */
	IloSymbolArray getSymbolArrayFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloSymbolArray getSymbolArrayFromColumn(IloInt tableIndex, IloInt column);
	/** <p> . </p> */
	IloSymbolSet getSymbolSetFromLine(IloInt tableIndex, IloInt line);
	/** <p> . </p> */
	IloSymbolSet getSymbolSetFromColumn(IloInt tableIndex, IloInt column);

	/** <p> . </p> */
	IloInt getIntFromTable(const char* tableName, IloInt x, IloInt y);
	/** <p> . </p> */
	IloNum getNumFromTable(const char* tableName, IloInt x, IloInt y);
	/** <p> . </p> */
	IloSymbol getSymbolFromTable(const char* tableName, IloInt x, IloInt y);

	/** <p> . </p> */
	IloInt getIntFromTable(IloInt tableIndex, IloInt x, IloInt y);
	/** <p> . </p> */
	IloNum getNumFromTable(IloInt tableIndex, IloInt x, IloInt y);
	/** <p> . </p> */
	IloSymbol getSymbolFromTable(IloInt tableIndex, IloInt x, IloInt y);

	/** <p> . </p> */
	IloTupleSet getTupleSet(IloTupleSchema schema, const char* tableName);

	/** <p> . </p> */
	IloIntArray2 getIntArray2ByLine(const char* tableName);
	/** <p> . </p> */
	IloNumArray2 getNumArray2ByLine(const char* tableName);
	/** <p> . </p> */
	IloSymbolArray2 getSymbolArray2ByLine(const char* tableName);

	/** <p> . </p> */
	IloIntSetArray getIntSetArrayByLine(const char* tableName);
	/** <p> . </p> */
	IloNumSetArray getNumSetArrayByLine(const char* tableName);
	/** <p> . </p> */
	IloSymbolSetArray getSymbolSetArrayByLine(const char* tableName);

	/** <p> . </p> */
	IloIntArray2 getIntArray2ByColumn(const char* tableName);
	/** <p> . </p> */
	IloNumArray2 getNumArray2ByColumn(const char* tableName);
	/** <p> . </p> */
	IloSymbolArray2 getSymbolArray2ByColumn(const char* tableName);

	/** <p> . </p> */
	IloIntSetArray getIntSetArrayByColumn(const char* tableName);
	/** <p> . </p> */
	IloNumSetArray getNumSetArrayByColumn(const char* tableName);
	/** <p> . </p> */
	IloSymbolSetArray getSymbolSetArrayByColumn(const char* tableName);
};

#ifdef ILO_MSVC
#ifndef ILO_WIN64
/**
* @group optim.concert.source
* @show internal
*
* <p>Excel DataSource.</p>
*/
class IloExcelDataSourceI : public IloRttiEnvObjectI{
	ILORTTIDECL
private:
	void closeConnexion();
	IloExcelSpreadsheet _reader;
	IloInt getIntCell(IloInt x, IloInt y);
	IloIntArray readIntArray(IloEnvI* env, IloInt i, IloInt j);
	IloNumArray readNumArray(IloEnvI* env, IloInt i, IloInt j);
	IloAnyArray readSymbolArray(IloEnvI* env, IloInt i, IloInt j);
    void fillTupleSet(IloTupleCollectionI* set, IloInt i, IloInt j);

	void write(IloIntArray ar, IloInt i, IloInt j);
	void write(IloNumArray ar, IloInt i, IloInt j);
	void write(IloAnyArray ar, IloInt i, IloInt j);
	void write(IloTupleCollectionI* ar, IloInt i, IloInt j);
	IloNum getFloatCell(IloInt x, IloInt y);
	const char* getStringCell(IloInt x, IloInt y);
public:
	IloExcelDataSourceI(IloEnv env, const char* fileName, IloBool readOnly = IloFalse);
	~IloExcelDataSourceI();

	IloIntArray getIntArrayFromLine(const char* range, IloInt line);
	IloIntArray getIntArrayFromColumn(const char* range, IloInt column);
	IloIntSet getIntSetFromLine(const char* range, IloInt line);
	IloIntSet getIntSetFromColumn(const char* range, IloInt column);

	IloNumArray getNumArrayFromLine(const char* range, IloInt line);
	IloNumArray getNumArrayFromColumn(const char* range, IloInt column);
	IloNumSet getNumSetFromLine(const char* range, IloInt line);
	IloNumSet getNumSetFromColumn(const char* range, IloInt column);

	IloSymbolArray getSymbolArrayFromLine(const char* range, IloInt line);
	IloSymbolArray getSymbolArrayFromColumn(const char* range, IloInt column);
	IloSymbolSet getSymbolSetFromLine(const char* range, IloInt line);
	IloSymbolSet getSymbolSetFromColumn(const char* range, IloInt column);

	IloInt getIntFromTable(const char* range, IloInt x, IloInt y);
	IloNum getNumFromTable(const char* range, IloInt x, IloInt y);
	IloSymbol getSymbolFromTable(const char* range, IloInt x, IloInt y);

	IloTupleSet getTupleSet(IloTupleSchema schema, const char* range);


	IloIntArray2 getIntArray2ByLine(const char* range);
	IloNumArray2 getNumArray2ByLine(const char* range);
	IloSymbolArray2 getSymbolArray2ByLine(const char* range);

	IloIntSetArray getIntSetArrayByLine(const char* range);
	IloNumSetArray getNumSetArrayByLine(const char* range);
	IloSymbolSetArray getSymbolSetArrayByLine(const char* range);

	IloIntArray2 getIntArray2ByColumn(const char* range);
	IloNumArray2 getNumArray2ByColumn(const char* range);
	IloSymbolArray2 getSymbolArray2ByColumn(const char* range);

	IloIntSetArray getIntSetArrayByColumn(const char* range);
	IloNumSetArray getNumSetArrayByColumn(const char* range);
	IloSymbolSetArray getSymbolSetArrayByColumn(const char* range);

    /* @internal Used by YOPL. */
    void readIntMap(IloMapI* result, const char* range);
    /* @internal Used by YOPL. */
    void readNumMap(IloMapI* result, const char* range);
    /* @internal Used by YOPL. */
    void readSymbolMap(IloMapI* result, const char* range);
    /* @internal Used by YOPL. */
    void readTupleMap(IloAbstractTupleMapI* result, const char* range);

    /* @internal Used by YOPL. */
    void readIntSet(IloIntSetI* result, const char* range);

    /* @internal Used by YOPL. */
    void readNumSet(IloNumSetI* result, const char* range);

    /* @internal Used by YOPL. */
    void readSymbolSet(IloAnySetI* result, const char* range);

    /* @internal Used by YOPL. */
    void readTupleSet(IloTupleSetI* result, const char* range);


    /* @internal Used by YOPL. */
    void writeIntSet(IloIntSetI* set, const char* range);

    /* @internal Used by YOPL. */
    void writeNumSet(IloNumSetI* set, const char* range);

    /* @internal Used by YOPL. */
    void writeSymbolSet(IloAnySetI* set, const char* range);

    /* @internal Used by YOPL. */
    void writeTupleSet(IloTupleSetI* set, const char* range);



    /* @internal Used by YOPL. */
    void writeInt(IloInt val, const char* range);

    /* @internal Used by YOPL. */
    void writeNum(IloNum val, const char* range);

    /* @internal Used by YOPL. */
    void writeSymbol(IloSymbolI* val, const char* range);

    /* @internal Used by YOPL. */
    void writeTuple(IloTupleI* tuple, const char* range);



    /* @internal Used by YOPL. */
    void writeIntMap(IloMapI* set, const char* range);
    /* @internal Used by YOPL. */
    void writeNumMap(IloMapI* set, const char* range);
    /* @internal Used by YOPL. */
    void writeSymbolMap(IloMapI* set, const char* range);
    /* @internal Used by YOPL. */
    void writeTupleMap(IloAbstractTupleMapI* set, const char* range);

	void save();
};

#endif //ILO_WIN64
#endif //ILO_MSVC


#endif


