// -------------------------------------------------------------- -*- C++ -*-
// OPL Studio source file
// --------------------------------------------------------------------------
//  Copyright (C) 1999-2001 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __CONCERT_iloexceldrvH
#define __CONCERT_iloexceldrvH


#if !defined(__CONCERT_ilodataportH)
#include <ilconcert/ilsource/ilodataport.h>
#endif

#if defined(ILO_MSVC)
#if !defined(ILO_WIN64)

#pragma  warning( disable : 4146 )
#import "ilconcert/ilsource/mso9.dll" no_namespace rename("DocumentProperties", "DocumentPropertiesXL") rename("RGB", "RBGXL")
#import "ilconcert/ilsource/vbe6ext.olb" no_namespace rename("_Windows", "_WindowsXL")
#import "ilconcert/ilsource/excel9.olb" rename("DialogBox", "DialogBoxXL") rename("RGB", "RBGXL") rename("DocumentProperties", "DocumentPropertiesXL") rename("CopyFile", "CopyFileXL") rename("ReplaceText", "ReplaceTextXL")


#if !defined(__CONCERT_iloenvH)
#include <ilconcert/iloenv.h>
#endif

class IloTupleCollectionI;
using namespace Excel;

/**
* @group optim.concert.source
* @show internal
*
* <p>Excel internal.</p>
*/
class IloExcelConnectionError : public IloException {
public:
  IloExcelConnectionError();
  IloExcelConnectionError(const wchar_t* message);
public:
  virtual ~IloExcelConnectionError();
};


class IloExcelReadOnlyError : public IloException {
public:
  IloExcelReadOnlyError();
public:
  virtual ~IloExcelReadOnlyError();
};

class IloExcelInstanceError : public IloException {
  IloInt _code;
public:
  IloExcelInstanceError();
public:
  virtual ~IloExcelInstanceError();
};
/**
* @group optim.concert.source
* @show internal
*
* <p>Excel internal.</p>
*/
class IloExcelConnection {
  enum {IloExcelErrSIZE = 1024};
  _ApplicationPtr _pXL;
  _WorkbookPtr _pBook;
  RangePtr _pRange;
  WorksheetFunctionPtr _pWsFunc;
  WorkbooksPtr _pWBooks;
  XlCalculation _calculation;
private:
  IloExcelConnection(const IloExcelConnection&);
  void operator=(const IloExcelConnection&);
  void end();
public:
//  IloExcelConnection(const char* xlsFile, const char* passwd, IloBool readOnly = IloFalse, IloBool visible = IloFalse);
  IloExcelConnection(const char* xlsFile, IloBool readOnly);
  ~IloExcelConnection();
  void setCurrentRange(const char* range);
  void setReference(IloInt vertOffset, IloInt horizOffset);
  IloInt getNumberOfRows();
  IloInt getNumberOfCols();

  IloIntArray readIntArray(IloEnvI* env, IloInt col, IloInt line);
  IloNumArray readNumArray(IloEnvI* env, IloInt col, IloInt line);
  IloAnyArray readSymbolArray(IloEnvI* env, IloInt col, IloInt line);
  void fillTupleSet(IloTupleCollectionI* set, IloInt i, IloInt j);

	void write(IloIntArray ar, IloInt i, IloInt j);
	void write(IloNumArray ar, IloInt i, IloInt j);
	void write(IloAnyArray ar, IloInt i, IloInt j);
	void write(IloTupleCollectionI* ar, IloInt i, IloInt j);
  IloBool isNumber(IloInt vertOffset, IloInt horizOffset);
  IloBool isString(IloInt vertOffset, IloInt horizOffset);
  /*BSTR for leftValue is allocated inside;
  it's the caller's job to free it :
  const bstring& getStringCell(IloInt vertOffset, IloInt horizOffset, bstring& leftValue);*/
  const char* getStringCell(IloInt vertOffset, IloInt horizOffset);//, char* leftValue);
  IloNum getFloatCell(IloInt vertOffset, IloInt horizOffset);
  IloInt getIntCell(IloInt vertOffset, IloInt horizOffset);

  void setStringCell(IloInt vertOffset, IloInt horizOffset, const char* value);
  void setFloatCell(IloInt vertOffset, IloInt horizOffset, IloNum value);
  void setIntCell(IloInt vertOffset, IloInt horizOffset, IloInt value);
  void save();
};

#endif // ILO_WIN64
#endif // ILO_MSVC

#endif




