// ---------------------------------------------------*- C++ -*--------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilorequestcacheH 
#define __CONCERT_ilorequestcacheH

#if !defined(__CONCERT_iloenvH)
# include <ilconcert/iloenv.h> 
#endif

#if !defined(__CONCERT_ilostringH)
# include <ilconcert/ilostring.h> 
#endif

#if !defined(__CONCERT_ilotuplebufferH)
# include <ilconcert/iltuple/ilotuplebuffer.h> 
#endif

#if !defined(__CONCERT_ilohashH)
# include <ilconcert/ilohash.h> 
#endif

#if !defined(__CONCERT_ilotuplecollectionhashH)
# include <ilconcert/iltuple/ilotuplecollectionhash.h> 
#endif

class IloQueryDataTableHash;
class IloTupleRequest;
class IloTupleRequestI;
class IloTupleSetI;
class IloTupleSet;

class IloIntDataColumnI;
class IloNumDataColumnI;
class IloAnyDataColumnI;

/**
* @group optim.concert.tuple
* @show internal
* <p> IloTupleRequestCacheI </p>
**/
class IloTupleRequestCacheI : public IloRttiEnvObjectI {
	ILORTTIDECL
private:
	IloBool _initialized;
protected:
	IloIntArray _empty;
	virtual void initSlicing(IloTupleRequestI* req)=0;
public:
	/** <p> . </p> */
	IloTupleRequestCacheI(IloEnv env, IloBool initialized=IloFalse);
	virtual ~IloTupleRequestCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute()=0;
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice)=0;
	/** <p> . </p> */
	void initialize(IloTupleRequestI* req);
};

IloBool IloMultipleIntCompFunction(IloInt** key1, IloInt** key2);
IloInt IloMultipleIntHashFunction(IloInt** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleIntHashTable </p>
**/
class IloMultipleIntHashTable : public IloEnvHashTable<IloInt**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleIntHashTable(IloEnv env, IloInt size); 
	virtual ~IloMultipleIntHashTable();
};

/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryIntCacheI </p>
**/
class IloNaryIntCacheI : public IloTupleRequestCacheI {
	ILORTTIDECL
private:
	IloInt _keySize;
	IloInt** _key;
	IloMultipleIntHashTable* _hash;
	virtual void initSlicing(IloTupleRequestI* req);
	void foo(IloEnvI* env, IloTupleSetI* coll, IloInt k, IloInt arity, IloIntDataColumnI** columns, IloIntSetI** sets, IloIntArray result);
public:
	/** <p> . </p> */
	IloNaryIntCacheI(IloEnv env,
		IloInt keySize, IloInt** key,
		IloMultipleIntHashTable* h,
		IloBool initialized=IloFalse);
	virtual ~IloNaryIntCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};

IloBool IloMultipleNumCompFunction(IloNum** key1, IloNum** key2);
IloInt IloMultipleNumHashFunction(IloNum** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleNumHashTable </p>
**/
class IloMultipleNumHashTable : public IloEnvHashTable<IloNum**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleNumHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleNumHashTable();
};

/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryNumCacheI </p>
**/
class IloNaryNumCacheI : public IloTupleRequestCacheI {
	ILORTTIDECL
private:
	IloInt _keySize;
	IloNum** _key;
	IloMultipleNumHashTable* _hash;
	virtual void initSlicing(IloTupleRequestI* req);
	void foo(IloEnvI* env, IloTupleSetI* coll, IloInt k, IloInt arity, IloNumDataColumnI** columns, IloNumSetI** sets, IloIntArray result);
public:
	/** <p> . </p> */
	IloNaryNumCacheI(IloEnv env, 
		IloInt keySize, IloNum** key,
		IloMultipleNumHashTable* h,
		IloBool initialized=IloFalse);
	virtual ~IloNaryNumCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};


IloBool IloMultipleAnyCompFunction(IloAny** key1, IloAny** key2);
IloInt IloMultipleAnyHashFunction(IloAny** key, IloInt size);

/**
* @group optim.concert.tuple
* @show internal
* <p> IloMultipleAnyHashTable </p>
**/
class IloMultipleAnyHashTable : public IloEnvHashTable<IloAny**, IloIntArrayI*> {
private:
	IloInt _size;
public:
	/** <p> . </p> */
	IloMultipleAnyHashTable(IloEnv env, IloInt size);
	virtual ~IloMultipleAnyHashTable();
};

/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryAnyCacheI </p>
**/
class IloNaryAnyCacheI : public IloTupleRequestCacheI {
	ILORTTIDECL
private:
	IloInt _keySize;
	IloAny** _key;
	IloMultipleAnyHashTable* _hash;
	virtual void initSlicing(IloTupleRequestI* req);
	void foo(IloEnvI* env, IloTupleSetI* coll, IloInt k, IloInt arity, IloAnyDataColumnI** columns, IloAnySetI** sets, IloIntArray result);
public:
	/** <p> . </p> */
	IloNaryAnyCacheI(IloEnv env, 
		IloInt keySize, 
		IloAny** key,
		IloMultipleAnyHashTable* h,
		IloBool initialized=IloFalse);
	virtual ~IloNaryAnyCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};


/**
* @group optim.concert.tuple
* @show internal
* <p> IloNaryCellCacheI </p>
**/
class IloNaryCellCacheI : public IloTupleRequestCacheI {
	ILORTTIDECL
private:
	IloTupleRequestI* _key;
	IloQueryDataTableHash* _hash;
	virtual void initSlicing(IloTupleRequestI* req);
public:
	/** <p> . </p> */
	IloNaryCellCacheI(IloEnv env, 
		IloTupleRequestI* key, 
		IloQueryDataTableHash* h,
		IloBool initialized=IloFalse);
	virtual ~IloNaryCellCacheI();
	/** <p> . </p> */
	virtual IloIntArrayI* execute();
	/** <p> . </p> */
	virtual IloBool store(IloIntArrayI* slice);
};


#endif

