// ---------------------------------------------------*- C++ -*--------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
#ifndef __CONCERT_ilotuplebufferH
#define __CONCERT_ilotuplebufferH

#if !defined(__CONCERT_ilocollectionH)
# include <ilconcert/ilocollection.h>
#endif

#if !defined(__CONCERT_ilolinkedlistH)
# include <ilconcert/ilolinkedlist.h>
#endif

class IloTupleI;
class IloTupleCollectionI;

/**
* @group optim.concert.tuple
* @show internal
* <p> TO BE DOCUMENTED?? </p>
**/
class IloTuplePath : public IloEnvObjectI {
public:
	/**
	* @group optim.concert.tuple
	* @show internal
	* <p> TO BE DOCUMENTED?? </p>
	**/
	class IloTupleCell {
	public:
		union Value{
			IloInt _int;
			IloNum _num;
			IloAny _any;
		};
	private:
		IloDataType _type;
		Value _value;		
	public:
		IloDataType getType() const { return _type; }
		Value getValue() const { return _value; }
		/** <p> . </p> */
		IloInt* getIntAdress() { return &(_value._int); }
		/** <p> . </p> */
		IloNum* getNumAdress() { return &(_value._num); }
		/** <p> . </p> */
		IloAny* getAnyAdress() { return &(_value._any); }

		/** <p> . </p> */
		IloBool isInt() const;
		/** <p> . </p> */
		IloBool isNum() const;
    /** <p> . </p> */
		IloBool isAny() const;

		/** <p> . </p> */
		IloInt getIntValue() const;
		/** <p> . </p> */
		IloNum getNumValue() const;
		/** <p> . </p> */
		IloAny getAnyValue() const;

		/** <p> . </p> */
		IloTupleCell(IloInt val);
		/** <p> . </p> */
		IloTupleCell(IloNum val);
		/** <p> . </p> */
		IloTupleCell(IloAny val);

		/** <p> . </p> */
		void setValue(IloInt val);
		/** <p> . </p> */
		void setValue(IloNum val);
		/** <p> . </p> */
		void setValue(IloAny val);
		~IloTupleCell(){}

    IloBool operator!=(const IloTupleCell& other) {
      if (_type != other.getType()) return IloTrue;
      if (_type == IntDataColumn) {
        return _value._int != other._value._int;
      } else if (_type == NumDataColumn) {
        return _value._num != other._value._num;
      } else {
        return _value._any != other._value._any;
      }
    }
	};
public:
  enum IloTupleRequestType {
    Equality = 0,
    LowerBound = 32,
    UpperBound = 64
  };

private:
	IloTupleCell _cell;
	IloIntArray _path;
  IloTupleRequestType _reqType;
public:
	/** <p> . </p> */
	IloTupleCell& getCell() { return _cell; }
	/** <p> . </p> */
	IloIntArray getPath() const { return _path; }
public:
	~IloTuplePath();

	/** <p> . </p> */
	void setValue(IloInt value);
	/** <p> . </p> */
	void setValue(IloNum value);
	/** <p> . </p> */
	void setValue(IloAny value);
	/** <p> . </p> */
	void setValue(IloDiscreteDataCollection val);
  /** <p> . </p> */
  IloTupleRequestType getRequestType() const {
    return _reqType;
  }
  /** <p> . </p> */
  IloBool isEquality() const {
    return _reqType==Equality;
  }
  /** <p> . </p> */
  IloBool isLowerBound() const {
    return _reqType==LowerBound;
  }
  /** <p> . </p> */
  IloBool isUpperBound() const {
    return _reqType==UpperBound;
  }

	IloTuplePath(IloIntArray path, IloTupleCell cell, IloTupleRequestType reqType = Equality): 
		IloEnvObjectI(path.getEnv().getImpl()), _cell(cell), _path(path), _reqType(reqType) {}
	/** <p> . </p> */
	IloTuplePath(IloEnv env, IloIntArray path, IloAny value, IloTupleRequestType reqType = Equality);
	/** <p> . </p> */
	IloTuplePath(IloEnv env, IloIntArray path, IloNum value, IloTupleRequestType reqType = Equality);
	/** <p> . </p> */
	IloTuplePath(IloEnv env, IloIntArray path, IloInt value, IloTupleRequestType reqType = Equality);
};

typedef IloArray<IloTuplePath*> IloTuplePathArray;
typedef IloArray<IloTuplePath::IloTupleCell> IloTupleCellArrayBase;
typedef IloDefaultArrayI IloTupleCellArrayI;

/**
* @group optim.concert.tuple
* @show internal
* <p> TO BE DOCUMENTED?? </p>
**/
class IloTupleCellArray : public IloTupleCellArrayBase {
public:
	typedef IloDefaultArrayI ImplClass;
	IloTupleCellArray(IloDefaultArrayI* i=0) : IloTupleCellArrayBase(i) {}
	IloTupleCellArray(const IloEnv env, IloInt n = 0) : IloTupleCellArrayBase(env, n) {}
	using IloArray<IloTuplePath::IloTupleCell>::add;
	IloTuplePath::IloTupleCell& operator[] (IloInt i) {
		return IloTupleCellArrayBase::operator[](i);
	}
	IloBool isHomogeneous() const;
	void convertTo(const IloTupleCollectionI* set);
	void display(ILOSTD(ostream)& os) const;
	IloTupleCellArray makeSlice(IloInt index, IloInt size);
	IloTupleCellArray fillSlice(IloTupleCellArray array, IloInt index, IloInt size);
	void endAll();
};

IloBool operator==(const IloTupleCellArray cells1, const IloTupleCellArray cells2);


typedef IloSimpleLinkedList<IloTuplePath*> IloTuplePathListBase;

/**
* @group optim.concert.tuple
* @show internal
* <p> TO BE DOCUMENTED?? </p>
**/
class IloTuplePathList : public IloSimpleLinkedList<IloTuplePath*> {
public:
	/** <p> . </p> */
	using IloSimpleLinkedList<IloTuplePath*>::add;
	/** <p> . </p> */
	IloTuplePathList(IloEnv env) : IloTuplePathListBase(env)  {}
	~IloTuplePathList();
	/** <p> . </p> */
	IloTuplePath* operator[] (IloInt i){
		return getObject(i);
	}
};


//-------------------------------------

/**
* @group optim.concert.tuple
* @show internal
* <p> TO BE DOCUMENTED?? </p>
**/
class IloTuplePathBufferI : public IloRttiEnvObjectI{
	ILORTTIDECL
	friend class IloTupleBufferI;
private:
	IloTuplePath* add(IloIntArray path, IloInt value);
	IloTuplePath* add(IloIntArray path, IloNum value);
	IloTuplePath* add(IloIntArray path, IloAny value);

	IloTuplePath* modify(IloTuplePath* tuple, IloInt value);
	IloTuplePath* modify(IloTuplePath* tuple, IloNum value);
	IloTuplePath* modify(IloTuplePath* tuple, IloAny value);

protected:
	IloTuplePathList _list;
	IloTuplePath* contains(IloIntArray array);
	IloTuplePath* contains(IloInt size, IloInt* path);
public:
	/** <p> . </p> */
	IloTuplePathBufferI(IloEnv env);
	virtual ~IloTuplePathBufferI();

	/** <p> . </p> */
	IloBool isEmpty() const { return _list.getSize() == 0; }
	/** <p> . </p> */
	IloBool isSingleton() const { return _list.getSize() == 1; }

	/** <p> . </p> */
	IloInt getSize() const { return _list.getSize(); }
	/** <p> . </p> */
	IloTuplePathList& getList() { return _list; }

	/** <p> . </p> */
	void clear() { _list.clear(); }
	/** <p> . </p> */
	void import(IloTuplePathBufferI* select);

	/** <p> . </p> */
	void import(IloInt idx1, IloTupleI* value);
	/** <p> . </p> */
	void import(IloInt idx1, IloInt idx2, IloTupleI* value);
	/** <p> . </p> */
	void import(IloInt idx1, IloInt idx2, IloInt idx3, IloTupleI* value);
	/** <p> . </p> */
	void import(IloIntArray path, IloTupleI* value);
	/** <p> . </p> */
	void import(IloInt pathSize, IloInt* path, IloTupleI* value);

	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt columnIndex, IloInt value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt columnIndex, IloNum value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt columnIndex, IloAny value);

	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloNum value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloAny value);

	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloInt value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloNum value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloAny value);

	/** <p> . </p> */
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloInt value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloNum value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloAny value);

	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt pathSize, IloInt* path, IloInt value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt pathSize, IloInt* path, IloNum value);
	/** <p> . </p> */
	IloTuplePath* addOnce(IloInt pathSize, IloInt* path, IloAny value);

	/** <p> . </p> */
	virtual void display(ILOSTD(ostream)& os) const;
};


/**
* @group optim.concert.tuple
* @show internal
* <p>An instance of this class offers a convenient way to represent a buffer for a IloTuple.</p>
*/
class IloTuplePathBuffer {
protected:
	IloTuplePathBufferI* _impl;
public:
	/** <p> Returns the env </p> **/
	IloEnv getEnv(){
		return _impl->getEnv();
	}

	/** <p> . </p> */
	IloTuplePathList& getList(){
		return _impl->getList();
	}

	/** <p> Constructor from an implementation. </p> **/
	IloTuplePathBuffer(IloTuplePathBufferI* impl) : _impl(impl){ }

	/** <p> This member function returns a pointer to the implementation
	* object of the invoking extractable object.
	* This member function is useful when you need to be sure that
	* you are using the same copy of the invoking extractable object
	* in more than one situation. </p>
	**/
	IloTuplePathBufferI* getImpl() const {
		return _impl;
	}

	/** <p> This member function deletes the invoking data domain.
	* That is, it frees all the resources used by the invoking object.
	* After a call to this member function, you can not use the invoking
	*  extractable object again.</p>
	**/
	void end(){
		if (_impl) {
			delete _impl; _impl = 0;
		}
	}
	/** <p> Select <i>value</i> from <i>columnName</i> </p> **/
	IloTuplePathBuffer(IloEnv env);

	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt columnIndex, IloInt value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(columnIndex, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt columnIndex, IloNum value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(columnIndex, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt columnIndex, IloAny value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(columnIndex, value);
	}

	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloInt value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(path, isArrayInternal, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloNum value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(path, isArrayInternal, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloIntArray path, IloBool isArrayInternal, IloAny value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(path, isArrayInternal, value);
	}

	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloNum value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloAny value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, value);
	}

	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloInt value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, idx3, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloNum value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, idx3, value);
	}
	/** <p> Makes a And jointure </p> **/
	IloTuplePath* addOnce(IloInt idx1, IloInt idx2, IloInt idx3, IloAny value){
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->addOnce(idx1, idx2, idx3, value);
	}


	/** <p> Displays the query </p> **/
	void display(ILOSTD(ostream)& os) const{
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		_impl->display(os);
	}
	/** <p> Returns the size. </p> **/
	IloInt getSize() const {
		IloAssert(getImpl() != 0, "IloTuplePathBuffer: Using empty handle");
		return _impl->getSize();
	}
};

#endif
