// -------------------------------------------------------------- -*- C++ -*-
//							     ILOG header file
// File: ilconcert/ilxml/iloiostream.h
// --------------------------------------------------------------------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
// Forward declaration of the iloiostream classes
// --------------------------------------------------------------------------
#ifndef __XML_iloiostreamH
#define __XML_iloiostreamH

#ifndef __CONCERT_ilosysH
#include <ilconcert/ilosys.h>
#endif
#ifndef __XML_ilomacrosH
#include <ilconcert/ilxml/ilomacros.h>
#endif

#if defined(IL_STD)
#if defined(_MSC_VER)
#include <wchar.h>
#endif
#include <iostream>
#if (defined(WINDOWS) || defined(PM)) && !defined(MAINWIN)
#define IloXmlInputStreamMode  (std::ios::in|std::ios::binary)
#define IloXmlOutputStreamMode (std::ios::out|std::ios::binary)
#define IloXmlBinaryInputStreamMode  (std::ios::in|std::ios::binary)
#define IloXmlBinaryOutputStreamMode (std::ios::out|std::ios::binary)
#else  /* (!WINDOWS && !PM) || MAINWIN */
#define IloXmlInputStreamMode  (std::ios::in)
#define IloXmlOutputStreamMode (std::ios::out)
#define IloXmlBinaryInputStreamMode  IloXmlInputStreamMode
#define IloXmlBinaryOutputStreamMode IloXmlOutputStreamMode
#endif /* (!WINDOWS && !PM) || MAINWIN */
#else  /* !IL_STD */
#  if defined(__SUNPRO_CC_COMPAT) && (__SUNPRO_CC_COMPAT >= 5)
#     include <iostream.h>
#  else
class istream;
class ostream;
#  endif
#if (defined(WINDOWS) || defined(PM)) && !defined(MAINWIN)
#define IloXmlInputStreamMode  (ios::in|ios::binary)
#define IloXmlOutputStreamMode (ios::out|ios::binary)
#define IloXmlBinaryInputStreamMode  (ios::in|ios::binary)
#define IloXmlBinaryOutputStreamMode (ios::out|ios::binary)
#else  /* (!WINDOWS && !PM) || MAINWIN */
#define IloXmlInputStreamMode  (ios::in)
#define IloXmlOutputStreamMode (ios::out)
#define IloXmlBinaryInputStreamMode  IloXmlInputStreamMode
#define IloXmlBinaryOutputStreamMode IloXmlOutputStreamMode
#endif /* (!WINDOWS && !PM) || MAINWIN */
#endif /* !IL_STD */

//char * IloGetString(ILOSTD_OSTREAM & stream);

#endif /* !__XML_iloiostreamH */
