// -------------------------------------------------------------- -*- C++ -*-
//							     ILOG header file
// File: include/ilconcert/ilxml/ilomemory.h
// --------------------------------------------------------------------------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------
// Declaration of memory management functions
// --------------------------------------------------------------------------
#ifndef __XML_ilomemoryH
#define __XML_ilomemoryH

#if !defined(__XML_ilomacrosH)
#include <ilconcert/ilxml/ilomacros.h>
#endif

#if defined(IL_STD)
#include <cstddef>
#else  /* ! IL_STD */
#include <stddef.h>
#endif /* ! IL_STD */

#if defined(_MSC_VER) && ((_MSC_VER < 1300) || defined(WIN64))/* msvc6. */
ILO_EXPORTEDFUNCTION(void*) IloXmlMalloc(size_t nBytes);
ILO_EXPORTEDFUNCTION(void*) IloXmlRealloc(void* block, size_t);
ILO_EXPORTEDFUNCTION(void*) IloXmlMemMove(void*, const void*, size_t);
#else  /* !msvc6 */
ILO_EXPORTEDFUNCTION(void*) IloXmlMalloc(IL_STDPREF size_t nBytes);
ILO_EXPORTEDFUNCTION(void*) IloXmlRealloc(void* block, IL_STDPREF size_t);
ILO_EXPORTEDFUNCTION(void*) IloXmlMemMove(void*, const void*, IL_STDPREF size_t);
#endif /* !msvc6. */
ILO_EXPORTEDFUNCTION(void)  IloXmlFree(void* block);
#define ILOXML_MALLOC(type, n)  ((type*)IloXmlMalloc((n)*sizeof(type)))
#define ILOXML_REALLOC(type, a, n) ((type*)IloXmlRealloc((IloXmlAny)(a), (n)*sizeof(type)))

#if defined(WINDOWS)
# define ILOXML_STRCASECMP(s1, s2) stricmp(s1, s2)
# define ILOXML_STRNCASECMP(s1, s2, n) strnicmp(s1, s2, n)
#else  /* !WINDOWS */
# if defined(sun) && !defined(__SVR4)
#  if defined(ILOXML_SUNCC2_1)
#   define ILOXML_STRCASECMP(s1, s2) strcasecmp((char*)(s1), (char*)(s2))
#   define ILOXML_STRNCASECMP(s1, s2, n) strncasecmp((char*)(s1), (char*)(s2), n)
#  else
#   define ILOXML_STRCASECMP(s1, s2) strcasecmp((char*)(s1), s2)
#   define ILOXML_STRNCASECMP(s1, s2, n) strncasecmp((char*)(s1), s2, n)
#  endif /* !ILOXML_SUNCC2_1 */
# else
#  define ILOXML_STRCASECMP(s1, s2) strcasecmp(s1, s2)
#  define ILOXML_STRNCASECMP(s1, s2, n) strncasecmp(s1, s2, n)
# endif /* ! (sun && !__SVR4) */
#endif /* !WINDOWS */
#if defined(_AIX) || defined(sinix)
#include <sys/types.h>
extern "C" {
    int strcasecmp(const char *, const char *);
    int strncasecmp(const char *, const char *, size_t);
}
#endif /* _AIX || sinix */

#endif /* !__XML_ilomemoryH */
