// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlconversionH
#define __XML_iloxmlconversionH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloConversionI;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_Conversion</code> enables to serialize a
 * IloConversionI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/

class IloXmlInfo_Conversion : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_Conversion::getTagName(); }
  IloXmlInfo_Conversion(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloConversionI* ConversionI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloConversionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

#endif
