// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlcpparraysH
#define __XML_iloxmlcpparraysH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINTARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlRange
// ----------------------------------------------------------*- C++ -*-------

class IloRangeArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_RangeArray</code> enables to serialize a
 * IloRangeArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_RangeArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_RangeArray::getTagName(); }
  IloXmlInfo_RangeArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloRangeArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloRangeArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloRangeArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloRangeArray array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINTARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSOS1
// ----------------------------------------------------------*- C++ -*-------

class IloSOS1Array;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_SOS1Array</code> enables to serialize a
 * IloSOS1Array in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_SOS1Array : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_SOS1Array::getTagName(); }
  IloXmlInfo_SOS1Array(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloSOS1Array* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloSOS1Array& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloSOS1Array* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloSOS1Array array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINTARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSOS2
// ----------------------------------------------------------*- C++ -*-------

class IloSOS2Array;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_SOS2Array</code> enables to serialize a
 * IloSOS2Array in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_SOS2Array : public IloXmlInfo {
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_SOS2Array::getTagName(); }
  IloXmlInfo_SOS2Array(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloSOS2Array* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloSOS2Array& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloSOS2Array* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloSOS2Array array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILONUMEXPRARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumVar
// ----------------------------------------------------------*- C++ -*-------

class IloNumVarArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_NumVarArray</code> enables to serialize a
 * IloNumVarArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumVarArray : public IloXmlInfo {
public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_NumVarArray::getTagName(); }
  IloXmlInfo_NumVarArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloNumVarArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloNumVarArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloNumVarArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloNumVarArray array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOINTEXPRARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntVar
// ----------------------------------------------------------*- C++ -*-------

class IloIntVarArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_IntVarArray</code> enables to serialize a
 * IloIntVarArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntVarArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntVarArray::getTagName(); }
  IloXmlInfo_IntVarArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloIntVarArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloIntVarArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloIntVarArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloIntVarArray array);
//




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOINTEXPRARRAY
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlBoolVar
// ----------------------------------------------------------*- C++ -*-------

class IloBoolVarArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_BoolVarArray</code> enables to serialize a
 * IloBoolVarArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_BoolVarArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_BoolVarArray::getTagName(); }
  IloXmlInfo_BoolVarArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloBoolVarArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloBoolVarArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloBoolVarArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloBoolVarArray array);
//




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOExtractableArray
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlConstraint
// ----------------------------------------------------------*- C++ -*-------

class IloConstraintArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_ConstraintArray</code> enables to serialize a
 * IloConstraintArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ConstraintArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_ConstraintArray::getTagName(); }
  IloXmlInfo_ConstraintArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloConstraintArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloConstraintArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloConstraintArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloConstraintArray array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOExtractableArray
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntExpr
// ----------------------------------------------------------*- C++ -*-------

class IloIntExprArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_IntExprArray</code> enables to serialize a
 * IloIntExprArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntExprArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntExprArray::getTagName(); }
  IloXmlInfo_IntExprArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloIntExprArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloIntExprArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloIntExprArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloIntExprArray array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOExtractableArray
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumExpr
// ----------------------------------------------------------*- C++ -*-------

class IloNumExprArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_NumExprArray</code> enables to serialize a
 * IloNumExprArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumExprArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_NumExprArray::getTagName(); }
  IloXmlInfo_NumExprArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloNumExprArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloNumExprArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloNumExprArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloNumExprArray array);
//







// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOExtractableArray
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumSetVar
// ----------------------------------------------------------*- C++ -*-------

class IloIntSetVarArray;

/**
 * @show internal
 *
 * @group optim.concert.xmlconcertarray
 *
 * <p>An instance of <code>IloXmlInfo_IntSetVarArray</code> enables to serialize a
 * IloIntSetVarArray in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntSetVarArray : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual const char* getTag() { return IloXmlInfo_IntSetVarArray::getTagName(); }
  IloXmlInfo_IntSetVarArray(IloXmlContextI* context);
  virtual int write(IloXmlWriter writer, IloIntSetVarArray* array, IloXmlElement* masterElement);
  virtual IloExtractableArray* readXmlArray(IloXmlReader reader, IloXmlElement* element);
  IloBool setVarContent(IloXmlWriter writer, IloIntSetVarArray& varArray, IloXmlElement* masterElement);
  IloBool checkSubElement(IloXmlReader reader, IloXmlElement* subElement, IloIntSetVarArray* varArray);


};

// Should be in the mother class IloXmlInfo:
//   IloBool writeVarArray(IloXmlWriter writer,
//                   IloXmlElement* element,
//                   IloIntSetVarArray array);
//






#endif


