// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlcppexpressionH
#define __XML_iloxmlcppexpressionH

#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------

// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcCos
// ----------------------------------------------------------*- C++ -*-------
class IloArcCosI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_ArcCos enables to serialize a IloArcCosI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcCos : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcCos::getTagName();
  }
  IloXmlInfo_ArcCos(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcCosI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloArcCosI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------

// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcSin
// ----------------------------------------------------------*- C++ -*-------

class IloArcSinI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_ArcSin enables to serialize a IloArcSinI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcSin : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcSin::getTagName();
  }
  IloXmlInfo_ArcSin(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcSinI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI, 
			IloXmlElement* masterElement){
    return write(writer, (IloArcSinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlArcTan
// ----------------------------------------------------------*- C++ -*-------


class IloArcTanI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_ArcTan enables to serialize a IloArcTanI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_ArcTan : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_ArcTan::getTagName();
  }
  IloXmlInfo_ArcTan(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, 
			IloArcTanI* exprI, 
			IloXmlElement* masterElement);
  
  virtual IloBool write(IloXmlWriter writer, 
			const IloRtti* extractableI,
			IloXmlElement* masterElement){
    return write(writer, (IloArcTanI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlCos
// ----------------------------------------------------------*- C++ -*-------


class IloCosI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Cos enables to serialize a IloCosI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Cos : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Cos::getTagName();
  }
  IloXmlInfo_Cos(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloCosI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloCosI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSin
// ----------------------------------------------------------*- C++ -*-------


class IloSinI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Sin enables to serialize a IloSinI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Sin : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Sin::getTagName();
  }
  IloXmlInfo_Sin(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSinI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlTan
// ----------------------------------------------------------*- C++ -*-------


class IloTanI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Tan enables to serialize a IloTanI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Tan : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Tan::getTagName();
  }
  IloXmlInfo_Tan(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloTanI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloTanI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloIntArrayElementI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntArrayElement enables to serialize a IloIntArrayElementI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntArrayElement : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntArrayElement::getTagName();
  }
  IloXmlInfo_IntArrayElement(IloXmlContextI* context);
  
  virtual IloBool write(IloXmlWriter writer, IloIntArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntExprArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloIntExprArrayElementI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntExprArrayElement enables to serialize a IloIntExprArrayElementI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntExprArrayElement : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntExprArrayElement::getTagName();
  }
  IloXmlInfo_IntExprArrayElement(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntExprArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntExprArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumExprArrayElement
// ----------------------------------------------------------*- C++ -*-------


class IloNumExprArrayElementI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumExprArrayElement enables to serialize a IloNumExprArrayElementI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumExprArrayElement : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumExprArrayElement::getTagName();
  }
  IloXmlInfo_NumExprArrayElement(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumExprArrayElementI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumExprArrayElementI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};



// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntModulo
// ----------------------------------------------------------*- C++ -*-------


class IloIntModuloI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntModulo enables to serialize a IloIntModuloI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntModulo : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntModulo::getTagName();
  }
  IloXmlInfo_IntModulo(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntModuloI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntModuloI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntModuloCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntModuloCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntModuloCst enables to serialize a IloIntModuloCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntModuloCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntModuloCst::getTagName();
  }
  IloXmlInfo_IntModuloCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntModuloCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntModuloCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




#endif


