// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmldiffH
#define __XML_iloxmldiffH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif

class IloDiffI;

/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 * <p>An instance of <code>IloXmlInfo_NumNeq</code> enables to serialize a
 * IloDiffI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/

class IloXmlInfo_NumNeq : public IloXmlInfo {

public:
  static const char* getTagName();

  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloRtti* exprI){
    return getTagElement(writer, (IloDiffI*)exprI);
  }
  virtual IloXmlElement* getTagElement(IloXmlWriter writer, const IloDiffI* exprI);

  virtual const char* getTag() { return IloXmlInfo_NumNeq::getTagName(); }
  IloXmlInfo_NumNeq(IloXmlContextI* context);
  virtual IloBool write(IloXmlWriter writer, IloDiffI* DiffI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloDiffI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


/**
 * @show internal
 * @group optim.concert.xmlconcert
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntNeq</code> enables to read a
 * IloDiffI with an IntExpr and an IntExpr as argument in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntNeq : public IloXmlInfo {
public:
  IloXmlInfo_IntNeq(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntNeq::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_IntNeqCst</code> enables to read a
 * IloDiffI with an IntExpr and an int as argument in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntNeqCst : public IloXmlInfo {
public:
  IloXmlInfo_IntNeqCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_IntNeqCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};

/**
 * @show internal
 * @group optim.concert.xmlconcert
 * <note> For compatibility with Java and C# </note>
 * <p> An instance of <code>IloXmlInfo_NumNeqCst</code> enables to read a
 * IloDiffI with an NumExpr and an int as argument in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumNeqCst : public IloXmlInfo {
public:
  IloXmlInfo_NumNeqCst(IloXmlContextI* context);
  static const char* getTagName();
  virtual const char* getTag() { return IloXmlInfo_NumNeqCst::getTagName(); }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


#endif
