// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmlexceptionH
#define __XML_iloxmlexceptionH

#if !defined(__CONCERT_iloenvH)
# include <ilconcert/iloenv.h>
#endif
#if !defined(__CONCERT_ilosysH)
# include <ilconcert/ilosys.h>
#endif


class IloXmlNotExtractable : public IloException {
public:
  IloXmlNotExtractable()
    : IloException("The object is not an IloExtractable"){}
};

class IloXmlStrLen : public IloException {
public:
  IloXmlStrLen()
    : IloException("XML are limited to 256 characters"){}
};

class IloXmlCheckVersion : public IloException {
public:
  IloXmlCheckVersion()
    : IloException("The XML has a bad version"){}
};

class IloXmlUnknownClass : public IloException {
public:
  IloXmlUnknownClass()
    : IloException("The Class is unknown for solution"){}
};

class IloXmlTagExistence : public IloException {
public:
  IloXmlTagExistence()
    : IloException("The Tag does not exist in this xml element.") {}
};

class IloXmlwriteSolution : public IloException {
public:
  IloXmlwriteSolution()
    : IloException("Bad method called.") {}
};

class IloXmlContextOpenStream : public IloException {
public:
  IloXmlContextOpenStream()
    : IloException("Problem with the XML stream.") {}
};

class IloXmlContextOpenDocument : public IloException {
public:
  IloXmlContextOpenDocument()
    : IloException("Impossible to open the XML document.") {}
};

class IloXmlContextNoRoot : public IloException {
public:
  IloXmlContextNoRoot()
    : IloException("Impossible to catch the Root in the XML document.") {}
};


class IloXmlBadTypeInXml : public IloException {
public:
  IloXmlBadTypeInXml()
    : IloException("Problem in the xml: the object is composed of bad types.") {}
};


class IloXmlReadNoRef : public IloException {
public:
  IloXmlReadNoRef()
    : IloException("No reference in the XML for the Solution reading.") {}
};

class IloXmlReadRefNotInMemory : public IloException {
public:
  IloXmlReadRefNotInMemory()
    : IloException("The Extractable in reference has not been yet created for the solution.") {}
};

class IloXmlWriteConstraint : public IloException {
public:
  IloXmlWriteConstraint()
    : IloException("ERROR: Try to write a IloConstraint.") {}
};

class IloXmlReadConstraint : public IloException {
public:
  IloXmlReadConstraint()
    : IloException("ERROR: Try to read a IloConstraint from the XML file.") {}
};


class IloXmlWriteExtractable : public IloException {
public:
  IloXmlWriteExtractable()
    : IloException("ERROR: Try to write a IloExtractable.") {}
};

class IloXmlReadExtractable : public IloException {
public:
  IloXmlReadExtractable()
    : IloException("ERROR: Try to read a IloExtractable from the XML file.") {}
};



class IloXmlregisterTypeIndexArray : public IloException {
public:
  IloXmlregisterTypeIndexArray()
    : IloException("Problem in the register of the xml classes for Array.") {}
};

class IloXmlregisterTypeIndex : public IloException {
public:
  IloXmlregisterTypeIndex()
    : IloException("Problem in the register of the xml classes.") {}
};

class IloXmlBadNumVarSolution : public IloException {
public:
  IloXmlBadNumVarSolution()
    : IloException("Value or Min or Max is undefined for IloNumVar Solution.") {}
};

#endif
