
// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------


#ifndef __XML_iloxmljavaconstraintH
#define __XML_iloxmljavaconstraintH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlDistributeV
// ----------------------------------------------------------*- C++ -*-------


class IloDistributeVI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_DistributeV enables to serialize a IloDistributeVI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_DistributeV : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_DistributeV::getTagName();
  }
  IloXmlInfo_DistributeV(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloDistributeVI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloDistributeVI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlAllDiff
// ----------------------------------------------------------*- C++ -*-------


class IloAllDiffI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_AllDiff enables to serialize a IloAllDiffI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_AllDiff : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_AllDiff::getTagName();
  }
  IloXmlInfo_AllDiff(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloAllDiffI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloAllDiffI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlInverse
// ----------------------------------------------------------*- C++ -*-------


class IloInverseI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Inverse enables to serialize a IloInverseI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Inverse : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Inverse::getTagName();
  }
  IloXmlInfo_Inverse(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloInverseI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloInverseI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlSetInverse
// ----------------------------------------------------------*- C++ -*-------


class IloSetInverseI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Inverse enables to serialize a IloInverseI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_SetInverse : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_SetInverse::getTagName();
  }
  IloXmlInfo_SetInverse(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloSetInverseI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloSetInverseI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntEqIntersection
// ----------------------------------------------------------*- C++ -*-------


class IloIntEqIntersectionI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntEqIntersection enables to serialize a IloIntEqIntersectionI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntEqIntersection : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntEqIntersection::getTagName();
  }
  IloXmlInfo_IntEqIntersection(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntEqIntersectionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntEqIntersectionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntEqUnion
// ----------------------------------------------------------*- C++ -*-------


class IloIntEqUnionI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntEqUnion enables to serialize a IloIntEqUnionI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntEqUnion : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntEqUnion::getTagName();
  }
  IloXmlInfo_IntEqUnion(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntEqUnionI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntEqUnionI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNot
// ----------------------------------------------------------*- C++ -*-------


class IloNotI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Not enables to serialize a IloNotI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Not : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Not::getTagName();
  }
  IloXmlInfo_Not(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNotI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNotI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIfThen
// ----------------------------------------------------------*- C++ -*-------


class IloIfThenI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IfThen enables to serialize a IloIfThenI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IfThen : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IfThen::getTagName();
  }
  IloXmlInfo_IfThen(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIfThenI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIfThenI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};






// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR A NEW ILOCONSTRAINT
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntAllNullIntersect
// ----------------------------------------------------------*- C++ -*-------


class IloIntAllNullIntersectI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntAllNullIntersect enables to serialize a IloIntAllNullIntersectI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntAllNullIntersect : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntAllNullIntersect::getTagName();
  }
  IloXmlInfo_IntAllNullIntersect(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntAllNullIntersectI* exprI, IloXmlElement* masterElement);
  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntAllNullIntersectI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




#endif


