
// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------



#ifndef __XML_iloxmljavaexpressionH
#define __XML_iloxmljavaexpressionH


#if !defined(__XML_iloxmlabstractH)
#include <ilconcert/iloxmlabstract.h>
#endif





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumTimesCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumTimesCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumTimesCst enables to serialize a IloNumTimesCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumTimesCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumTimesCst::getTagName();
  }
  IloXmlInfo_NumTimesCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumTimesCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumTimesCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumTimes
// ----------------------------------------------------------*- C++ -*-------


class IloNumTimesI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumTimes enables to serialize a IloNumTimesI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumTimes : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumTimes::getTagName();
  }
  IloXmlInfo_NumTimes(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumTimesI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumTimesI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntTimesCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntTimesCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntTimesCst enables to serialize a IloIntTimesCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntTimesCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntTimesCst::getTagName();
  }
  IloXmlInfo_IntTimesCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntTimesCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntTimesCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntTimes
// ----------------------------------------------------------*- C++ -*-------


class IloIntTimesI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntTimes enables to serialize a IloIntTimesI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntTimes : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntTimes::getTagName();
  }
  IloXmlInfo_IntTimes(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntTimesI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntTimesI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMin
// ----------------------------------------------------------*- C++ -*-------


class IloIntMinI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMin enables to serialize a IloIntMinI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMin : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMin::getTagName();
  }
  IloXmlInfo_IntMin(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMinI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMax
// ----------------------------------------------------------*- C++ -*-------


class IloIntMaxI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMax enables to serialize a IloIntMaxI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMax : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMax::getTagName();
  }
  IloXmlInfo_IntMax(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMaxI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMaxI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMinCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntMinCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMinCst enables to serialize a IloIntMinCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMinCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMinCst::getTagName();
  }
  IloXmlInfo_IntMinCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMinCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMinCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMaxCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntMaxCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMaxCst enables to serialize a IloIntMaxCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMaxCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMaxCst::getTagName();
  }
  IloXmlInfo_IntMaxCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMaxCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMaxCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntDiv
// ----------------------------------------------------------*- C++ -*-------


class IloIntDivI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntDiv enables to serialize a IloIntDivI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntDiv : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntDiv::getTagName();
  }
  IloXmlInfo_IntDiv(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntDivI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntDivI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntDivCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntDivCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntDivCst enables to serialize a IloIntDivCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntDivCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntDivCst::getTagName();
  }
  IloXmlInfo_IntDivCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntDivCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntDivCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntRecDivCst
// ----------------------------------------------------------*- C++ -*-------


class IloIntRecDivCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntRecDivCst enables to serialize a IloIntRecDivCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntRecDivCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntRecDivCst::getTagName();
  }
  IloXmlInfo_IntRecDivCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntRecDivCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntRecDivCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlExponent
// ----------------------------------------------------------*- C++ -*-------


class IloExponentI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Exponent enables to serialize a IloExponentI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Exponent : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Exponent::getTagName();
  }
  IloXmlInfo_Exponent(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloExponentI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloExponentI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlLog
// ----------------------------------------------------------*- C++ -*-------


class IloLogI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_Log enables to serialize a IloLogI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_Log : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_Log::getTagName();
  }
  IloXmlInfo_Log(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloLogI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloLogI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumSquare
// ----------------------------------------------------------*- C++ -*-------


class IloNumSquareI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumSquare enables to serialize a IloNumSquareI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumSquare : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumSquare::getTagName();
  }
  IloXmlInfo_NumSquare(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumSquareI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumSquareI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntSquare
// ----------------------------------------------------------*- C++ -*-------


class IloIntSquareI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntSquare enables to serialize a IloIntSquareI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntSquare : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntSquare::getTagName();
  }
  IloXmlInfo_IntSquare(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntSquareI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntSquareI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumAbs
// ----------------------------------------------------------*- C++ -*-------


class IloNumAbsI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumAbs enables to serialize a IloNumAbsI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumAbs : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumAbs::getTagName();
  }
  IloXmlInfo_NumAbs(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumAbsI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumAbsI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntAbs
// ----------------------------------------------------------*- C++ -*-------


class IloIntAbsI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntAbs enables to serialize a IloIntAbsI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntAbs : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntAbs::getTagName();
  }
  IloXmlInfo_IntAbs(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntAbsI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntAbsI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumPowerCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumPowerCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumPowerCst enables to serialize a IloNumPowerCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumPowerCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumPowerCst::getTagName();
  }
  IloXmlInfo_NumPowerCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumPowerCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumPowerCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumRecPowerCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumRecPowerCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumRecPowerCst enables to serialize a IloNumRecPowerCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumRecPowerCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumRecPowerCst::getTagName();
  }
  IloXmlInfo_NumRecPowerCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumRecPowerCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumRecPowerCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumPower
// ----------------------------------------------------------*- C++ -*-------


class IloNumPowerI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumPower enables to serialize a IloNumPowerI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumPower : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumPower::getTagName();
  }
  IloXmlInfo_NumPower(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumPowerI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumPowerI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMinArray
// ----------------------------------------------------------*- C++ -*-------


class IloIntMinArrayI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMinArray enables to serialize a IloIntMinArrayI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMinArray : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMinArray::getTagName();
  }
  IloXmlInfo_IntMinArray(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMinArrayI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMinArrayI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMinArray
// ----------------------------------------------------------*- C++ -*-------


class IloNumMinArrayI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMinArray enables to serialize a IloNumMinArrayI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMinArray : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMinArray::getTagName();
  }
  IloXmlInfo_NumMinArray(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMinArrayI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMinArrayI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlIntMaxArray
// ----------------------------------------------------------*- C++ -*-------


class IloIntMaxArrayI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_IntMaxArray enables to serialize a IloIntMaxArrayI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_IntMaxArray : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_IntMaxArray::getTagName();
  }
  IloXmlInfo_IntMaxArray(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloIntMaxArrayI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloIntMaxArrayI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMaxArray
// ----------------------------------------------------------*- C++ -*-------


class IloNumMaxArrayI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMaxArray enables to serialize a IloNumMaxArrayI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMaxArray : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMaxArray::getTagName();
  }
  IloXmlInfo_NumMaxArray(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMaxArrayI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMaxArrayI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumDiv
// ----------------------------------------------------------*- C++ -*-------


class IloNumDivI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumDiv enables to serialize a IloNumDivI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumDiv : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumDiv::getTagName();
  }
  IloXmlInfo_NumDiv(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumDivI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumDivI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumDivCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumDivCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumDivCst enables to serialize a IloNumDivCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumDivCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumDivCst::getTagName();
  }
  IloXmlInfo_NumDivCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumDivCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumDivCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumRecDivCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumRecDivCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumRecDivCst enables to serialize a IloNumRecDivCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumRecDivCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumRecDivCst::getTagName();
  }
  IloXmlInfo_NumRecDivCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumRecDivCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumRecDivCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMin
// ----------------------------------------------------------*- C++ -*-------


class IloNumMinI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMin enables to serialize a IloNumMinI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMin : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMin::getTagName();
  }
  IloXmlInfo_NumMin(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMinI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMinI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMinCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumMinCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMinCst enables to serialize a IloNumMinCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMinCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMinCst::getTagName();
  }
  IloXmlInfo_NumMinCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMinCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMinCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMax
// ----------------------------------------------------------*- C++ -*-------


class IloNumMaxI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMax enables to serialize a IloNumMaxI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMax : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMax::getTagName();
  }
  IloXmlInfo_NumMax(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMaxI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMaxI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};





// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------
//
//    INCLUDE CODE FOR XML OF A NEW ILOEXPR
//
// ----------------------------------------------------------*- C++ -*-------
// ----------------------------------------------------------*- C++ -*-------


// ----------------------------------------------------------*- C++ -*-------
//    INCLUDE FOR IloXmlNumMaxCst
// ----------------------------------------------------------*- C++ -*-------


class IloNumMaxCstI;


/**
 * @show internal
 * @group optim.concert.xmlconcert
 *
 *<p>An instance of IloXmlInfo_NumMaxCst enables to serialize a IloNumMaxCstI in xml. </p>
 * @see IloXmlContextI
 * @see IloXmlInfo
 * @see IloXmlReader
 * @see IloXmlWriter
 **/
class IloXmlInfo_NumMaxCst : public IloXmlInfo {
public:
  static const char* getTagName();
  virtual const char* getTag() {
    return IloXmlInfo_NumMaxCst::getTagName();
  }
  IloXmlInfo_NumMaxCst(IloXmlContextI* context);

  virtual IloBool write(IloXmlWriter writer, IloNumMaxCstI* exprI, IloXmlElement* masterElement);

  virtual IloBool write(IloXmlWriter writer, const IloRtti* extractableI, IloXmlElement* masterElement){
    return write(writer, (IloNumMaxCstI*)extractableI, masterElement);
  }
  virtual IloRtti* read(IloXmlReader reader, IloXmlElement* element);
};




#endif


