// ----------------------------------------------------------*- C++ -*-------
//  Copyright (C) 1990-2006 by ILOG.
//  All Rights Reserved.
//
//  N O T I C E
//
//  THIS MATERIAL IS CONSIDERED A TRADE SECRET BY ILOG.
//  UNAUTHORIZED ACCESS, USE, REPRODUCTION OR DISTRIBUTION IS PROHIBITED.
// --------------------------------------------------------------------------

#ifndef __XML_iloxmltoolH
#define __XML_iloxmltoolH


#if !defined(__CONCERT_iloenvH)
#include <ilconcert/iloenv.h>
#endif
#if !defined(__CONCERT_iloanyH)
#include <ilconcert/iloany.h>
#endif

#if !defined(__CONCERT_iloexpressioniH)
# include <ilconcert/iloexpressioni.h>
#endif

#if !defined(__CONCERT_ilosysH)
# include <ilconcert/ilosys.h>
#endif
#if !defined(__CONCERT_ilomodelH)
# include <ilconcert/ilomodel.h>
#endif
#if !defined(__CONCERT_ilomodeliH)
# include <ilconcert/ilomodeli.h>
#endif

#if !defined(__CONCERT_ilolinearH)
# include <ilconcert/ilolinear.h>
#endif

#if !defined(__CONCERT_iloexpressionH)
# include <ilconcert/iloexpression.h>
#endif


#if !defined(__XML_iloxmlabstractH)
# include <ilconcert/iloxmlabstract.h>
#endif

class IloSymbolSet;

class IloXmlPrintInformationI : public IloEnvObjectI {
private: 
  IloAnySet _typeInfo;
  IloAnySet _typeName;
  IloBool _flag;

  void registerAll();
 
  void printInfo(IloModel model, const char* name, IloTypeInfo type);
  void printInfo(IloModel model1, IloModel model2, const char* name, IloTypeInfo type);
  
  void printInfo(IloEnv env, const char* name, IloTypeInfo type);
  void printInfo(IloEnv env1, IloEnv env2, const char* name, IloTypeInfo type);

public:
  IloXmlPrintInformationI(IloEnv env);
  ~IloXmlPrintInformationI();

  IloInt countRttiObject(IloModel model, IloTypeInfo typeinfo);
  IloInt countRttiObject(IloEnv env, IloTypeInfo typeinfo);

  IloSymbolSet checkForUnknown(IloEnv env);
  void registerObject(const char* name, IloTypeInfo type);
  void printInformation(IloModel model);
  IloBool printDiffCountInformation(IloModel model1, IloModel model2);
  void printInformation(IloEnv env);
  IloBool printDiffCountInformation(IloEnv env1, IloEnv env2);
};


class IloXmlPrintInformation {
private:
  IloXmlPrintInformationI* _impl;
public:
  IloXmlPrintInformation(IloEnv env){
    _impl = new (env)IloXmlPrintInformationI(env);
  }
  void end(){
   if (_impl) {
      delete _impl; _impl = 0;
   }
  }

  IloXmlPrintInformationI* getImpl() { return _impl; }

  void registerObject(const char* name, IloTypeInfo type){
    _impl->registerObject(name, type);
  }
  void printInformation(IloModel model){
    _impl->printInformation(model);
  }
  IloBool printDiffCountInformation(IloModel model1, IloModel model2){
    return _impl->printDiffCountInformation(model1, model2);
  }
  void printInformation(IloEnv env){
    _impl->printInformation(env);
  }
  IloBool printDiffCountInformation(IloEnv env1, IloEnv env2){
    return _impl->printDiffCountInformation(env1, env2);
  }
};

#endif
